// -------------------------------------------------------------------------------
// 
// 		cwCu		AndroidpTEhvOwb_t@C
// 
// 				Ver 3.24e
// 
// -------------------------------------------------------------------------------

#ifndef DX_SOUNDANDROID_H
#define DX_SOUNDANDROID_H

#include "../DxCompileConfig.h"

#ifndef DX_NON_SOUND

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxThread.h"

#include <SLES/OpenSLES.h>
#include <SLES/OpenSLES_Android.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// Xg[֌W̒`
#define STS_BUFSEC_FILE						(256)			// Xg[TEhĐɊmۂTEhobt@̎( Pʂ STS_DIVNUM1b )( t@C̃Xg[Đp )
#define STS_ADVANCECOPYSEC_FILE				(192)			// Xg[TEhĐɉf[^sWJĂő厞( Pʂ STS_DIVNUM1b )( t@C̃Xg[Đp )
#define STS_MINADVANCECOPYSEC_FILE			(96)			// Xg[TEhĐɉf[^sWJĂŏ( Pʂ STS_DIVNUM1b )( t@C̃Xg[Đp )

// ̃obt@[L[̃obt@̐
#define BUFFERQUEUE_BUFFER_NUM				(16)

// TEhobt@Đp̍ő吔
#define SOUNDBUFFERPLAYINFO_MAX_NUM			(512)

// \̒` --------------------------------------------------------------------

// obt@L[ɓnf[^̏
struct BUFFERENQUEUE_INFO
{
	DWORD							CompPos ;
	DWORD							AddBytes ;
	WORD							WorkBufferIndex ;
	WORD							Padding ;
} ;

// TEhobt@Đp\
struct SOUNDBUFFERPLAYINFO
{
	int								SetupFlag ;							// o̓IuWFNgȂǂ̍쐬ςł邩ǂ̃tO
	int								UseFlag ;							// Đ̂߂ɎgpĂ邩ǂ̃tO

	DWORD							Channels ;							// `l
	DWORD							BitsPerSample ;						// PTṽrbg
	DWORD							SamplesPerSec ;						// Đg

	SLObjectItf						OutputMixObject ;					// o̓IuWFNg
	SLObjectItf						PlayerObject;						// vC[IuWFNg
	SLPlayItf						PlayerPlayInterface ;				// vC[ĐC^tF[X
	SLAndroidSimpleBufferQueueItf	PlayerBufferQueueInterface ;		// vC[obt@L[C^tF[X
	SLVolumeItf						PlayerVolumeInterface ;				// vC[ʃC^tF[X
	SLEqualizerItf					PlayerEqualizerInterface ;			// vC[CRCUC^tF[X
} ;

// TEhobt@ˑ\
struct SOUNDBUFFER_PF
{
	DX_CRITICAL_SECTION				CriticalSection ;					// NeBJZNV

	void *							WorkBufferBase ;					// gύXƗpobt@
	void *							WorkBuffer[ BUFFERQUEUE_BUFFER_NUM ] ;	// gύXƗpobt@̃AhX
	BYTE							WorkBufferUseFlag[ BUFFERQUEUE_BUFFER_NUM ] ;	// gύXƗpobt@gpĂ邩ǂ̃tO

	volatile int					EnqueueInfoNum ;					// obt@L[ɓnf[^̐
	volatile BUFFERENQUEUE_INFO		EnqueueInfo[ BUFFERQUEUE_BUFFER_NUM ] ;	// obt@L[ɓnf[^̏

	int								BufferEndPlayEnqueueNum ;			// obt@L[ɍĐĨL[ς񂾉

	int								PlaySetupComp ;						// ĐłĂ邩( TRUE:łĂ  FALSE:łĂȂ )
	int								UseSoundBufferPlayInfoIndex ;		// gpĂĐp
//	SLObjectItf						OutputMixObject ;					// o̓IuWFNg
//	SLObjectItf						PlayerObject;						// vC[IuWFNg
//	SLPlayItf						PlayerPlayInterface ;				// vC[ĐC^tF[X
//	SLAndroidSimpleBufferQueueItf	PlayerBufferQueueInterface ;		// vC[obt@L[C^tF[X
//	SLVolumeItf						PlayerVolumeInterface ;				// vC[ʃC^tF[X

	int								StopSoundBufferValid ;
	struct SOUNDBUFFER *			StopSoundBufferPrev ;
	struct SOUNDBUFFER *			StopSoundBufferNext ;
} ;

// CRCU[̃oh
struct EQUALIZER_BAND_INFO
{
	int							Level ;
	int							CenterFrequency ;
	int							FrequencyMin ;
	int							FrequencyMax ;
} ;

// CRCU[̃vZbg
struct EQUALIZER_PRESET_INFO
{
	TCHAR						Name[ 256 ] ;
} ;

// CRCU[
struct SOUNDBUFFER_EQUALIZER_INFO
{
	int							Enabled ;
	int							BandNum ;
	EQUALIZER_BAND_INFO			*BandInfo ;
	int							BandLevelRangeMin ;
	int							BandLevelRangeMax ;
	int							PresetNum ;
	EQUALIZER_PRESET_INFO		*PresetInfo ;
	int							CurrentPresetIndex ;
} ;

// TEhVXepˑf[^\
struct SOUNDSYSTEMDATA_PF
{
	int							EngineObjectInitialize ;
	SLObjectItf					EngineObject ;							// GWIuWFNg
	SLEngineItf					EngineInterface ;						// GWC^tF[X

	pthread_t					ProcessSoundThread ;					// ProcessStreamSoundMemAll ĂԃXbhID
	volatile int				ProcessSoundThreadEndRequest ;			// ProcessStreamSoundMemAll ĂԃXbhI邩ǂ

	int							DXSoundProcessStart ;					// cwCũTEhJnǂ

	int							AudioManager_SampleRate ;				// I[fBIfoCXɓKTvO[g
	int							AudioManager_FramesPerBuffer ;			// I[fBIfoCXɓKobt@TCY

	SLObjectItf						SelfMixing_OutputMixObject ;			// O~LVOp@o̓IuWFNg
	BYTE *							SelfMixing_OutputBuffer ;				// O~LVOp@o͗pobt@
	SLObjectItf						SelfMixing_PlayerObject;				// O~LVOp@vC[IuWFNg
	SLPlayItf						SelfMixing_PlayerPlayInterface ;		// O~LVOp@vC[ĐC^tF[X
	SLAndroidSimpleBufferQueueItf	SelfMixing_PlayerBufferQueueInterface ;	// O~LVOp@vC[obt@L[C^tF[X
	ULONGLONG						SelfMixing_TotalPlaySampleCount ;		// O~LVOōĐTv

	int							UseEqualizer ;							// CRCU[@\gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	SOUNDBUFFER_EQUALIZER_INFO	EqualizerInfo ;							// CRCU[

	DX_CRITICAL_SECTION			StopSoundBufferCriticalSection ;		// NeBJZNV
	struct SOUNDBUFFER *		StopSoundBuffer ;

	DX_CRITICAL_SECTION			SoundBufferPlayInfosCriticalSection ;					// TEhobt@̍ĐɕKvȏp̃NeBJZNV
	int							SoundBufferPlayInfoSetupErrorNum ;						// TEhobt@̍ĐɕKvȏ̃ZbgAbvɎsۂ̃ZbgAbvςłvf
	int							SoundBufferPlayInfoSetupNum ;							// TEhobt@̍ĐɕKvȏ̃ZbgAbvςłvf̐
	SOUNDBUFFERPLAYINFO			SoundBufferPlayInfos[ SOUNDBUFFERPLAYINFO_MAX_NUM ] ;	// TEhobt@̍ĐɕKvȏ̍\
} ;

// lhchf[^ˑ
struct MIDIHANDLEDATA_PF
{
	int							Dummy ;
} ;

// lhchVXepˑf[^\
struct MIDISYSTEMDATA_PF
{
	int							Dummy ;
} ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		MidiCallBackProcess( void ) ;																			// lhchtIĂ΂R[obN֐

extern	void	SoundBuffer_Apply_StopSoundBufferList( void ) ;							// ~҂TEhobt@Xgɓo^ĂTEhobt@~


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_SOUND

#endif // DX_SOUNDANDROID_H
