// -------------------------------------------------------------------------------
// 
// 		cwCu		GraphFilternvOwb_t@C
// 
// 				Ver 3.24e
// 
// -------------------------------------------------------------------------------

#ifndef DX_GRAPHICSFILTER_H
#define DX_GRAPHICSFILTER_H

#include "DxCompileConfig.h"

#ifndef DX_NON_FILTER

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxGraphics.h"
#include <stdarg.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------


// \̒` --------------------------------------------------------------------

// tB^[\
struct GRAPHFILTER_INFO
{
	int						BlendGraphScalingFilterIsBilinear ;
	int						BltBlendMode ;
	int						IsBlend ;
	int						FilterOrBlendType ;
	int						SrcGrHandle ;
	int						BlendGrHandle ;
	int						DestGrHandle ;
	int						SrcEqualDestClearFlag ;
	float					BlendRatio ;
	int						Pass ;
	int						SrcX1 ;
	int						SrcY1 ;
	int						SrcX2 ;
	int						SrcY2 ;
	int						SrcDivNum ;
	int						BlendX ;
	int						BlendY ;
	int						BlendPosEnable ;
	int						BlendX2 ;
	int						BlendY2 ;
	int						BlendPos2Enable ;
	int						DestX ;
	int						DestY ;

	int						PassNum ;
	int						UseWorkScreen ;

	int						DestWidth ;
	int						DestHeight ;
	BASEIMAGE				SrcBaseImage ;
	BASEIMAGE				BlendBaseImage ;
	BASEIMAGE				DestBaseImage ;

	IMAGEDATA				*SrcImage ;
	IMAGEDATA				*DestImage ;
	IMAGEDATA				*BlendImage ;
	IMAGEDATA				*TargetScreenImage ;
} ;

// tB^[
struct GRAPHFILTER_PARAM
{
	int						Gauss_PixelWidth ;
	float					Gauss_Param ;
	int						Bright_Clip_CmpType ;
	float					Bright_Clip_CmpParam ;
	int						Bright_Clip_ClipFillFlag ;
	COLOR_F					Bright_Clip_ClipFillColor ;
	int						Bright_Scale_Min ;
	int						Bright_Scale_Max ;
	int						Hsb_HueType ;
	float					Hsb_Hue ;
	float					Hsb_Saturation ;
	float					Hsb_Bright ;
	float					Mono_Cb ;
	float					Mono_Cr ;
	float					Lv_Min ;
	float					Lv_Max ;
	float					Lv_Gamma ;
	float					Lv_AfterMin ;
	float					Lv_AfterMax ;
	float					TC_Threshold ;
	COLOR_F					TC_LowColor ;
	COLOR_F					TC_HighColor ;
	int						GM_MapGrHandle ;
	int						GM_Reverse ;
	int						UVGrHandle ;
	int						DestSizeX ;
	int						DestSizeY ;
	COLOR_U8				TargetColor ;
	COLOR_U8				NextColor ;
	int						DepthMapGrHandle ;
	float					SSAO_KernelRadius ;
	float					SSAO_MinDistance ;
	float					SSAO_MaxDistance ;
	float					SSAO_Strength ;
	int						SSAO_OcclusionColor ;
	float					SSAO_OcclusionPower ;
	int						SSAO_ColorMapHandle ;
	COLOR_F					ColorScale ;
	COLOR_F					ColorPreSub ;

	int						RGBA_R ;
	int						RGBA_G ;
	int						RGBA_B ;
	int						RGBA_A ;
} ;

// tB^[̃VF[_[nh
struct GRAPHFILTER_SHADER_HANDLE
{
	int						Gauss_PS[ 3 ] ;							// KEXtB^̃sNZVF[_[
	int						BrightClipPS[ 2 ][ 2 ][ 2 ] ;			// 邳ŃNbvtB^̃sNZVF[_[[ 1:ȏNbv  0:ȉNbv ][ 1:NbvhԂ 0:hԂȂ ][ 0:ʏp  1:Zς݃At@p ]
	int						BrightScalePS[ 2 ] ;					// w̖邳̗̈g傷tB^̃sNZVF[_[[ 0:ʏp  1:Zς݃At@p ]
	int						DownScalePS[ 3 ] ;						// ktB^[( 0:X2 1:X4 2:X8 )
	int						HsbPS[ 3 ][ 2 ] ;						// gratB^[[ 0:RGB to HSI  1:HSI to RGB  2:HSB  HLock ][ 0:ʏp  1:Zς݃At@p ]
	int						MonoPS ;								// mg[tB^[
	int						InvertPS[ 2 ] ;							// K]tB^[[ 0:ʏp  1:Zς݃At@p ]
	int						LevelPS[ 2 ] ;							// x␳tB^[[ 0:ʏp  1:Zς݃At@p ]
	int						GammaTex ;								// K}␳Ɏgp摜
	float					PrevGamma ;								// ÕK}tB^̍ۂ̃K}l
	int						TwoColorPS[ 2 ] ;						// QltB^[[ 0:ʏp  1:Zς݃At@p ]
	int						GradientMapPS[ 2 ][ 2 ] ;				// Of[V}bvtB^[[ 0:ʏp  1:Zς݃At@p ]
	int						ReplacementPS[ 2 ] ;					// F̒u[ 0:ʏp  1:Zς݃At@p ]
	int						PreMulAlphaPS ;							// ʏ摜Zς݃At@摜쐬ׂ̃tB^[
	int						InterpAlphaPS ;							// Zς݃At@摜ʏ摜쐬ׂ̃tB^[
	int						YUVtoRGBPS[ 4 ] ;						// YUVJ[RGBJ[ɕϊtB^[
	int						BicubicPS ;								// oCL[rbNԃtB^[
	int						Lanczos3PS ;							// Lanczos-3ԃtB^[
	int						SSAOPS[ 3 ] ;							// SSAOtB^[
	int						SSAOMixPS ;								// SSAỎBWƃJ[obt@tB^[
	int						FloatColorScalePS ;						// FloatColorScaletB^[

	int						BasicBlendPS[ DX_GRAPH_BLEND_NUM ] ;	// {IȃuhtB^[
	int						RgbaMixBasePS[ 2 ] ;					// RGBAMixuh{[ 0:ʏp  1:Zς݃At@p ]
	int						RgbaMixSRGBB[ 4 ][ 2 ] ;				// RGBAMixuh A  BRGBA ̂S[ 0:ʏp  1:Zς݃At@p ]
	int						RgbaMixSRRRB[ 4 ][ 4 ][ 2 ] ;			// RGBAMixuh SYYY BX ̂PU [ Y ][ X ][ 0:ʏp  1:Zς݃At@p ]
	int						RgbaMixS[ 4 ][ 4 ][ 4 ][ 4 ][ 2 ] ;		// RGBAMixuh S ̑gݍ킹256[ R ][ G ][ B ][ A ][ 0:ʏp  1:Zς݃At@p ]
} ;

// tB^[̃VXef[^
struct GRAPHFILTER_SYSTEM_DATA
{
	int						BlendGraphScalingFilterIsNotBilinear ;	// SrcGrHandle  BlendGrHandle ̃TCYقȂꍇ̃XP[OtB^[[h̓oCjAł͂Ȃǂ
	int						BltBlendMode ;							// ]Ƃ̃uh[h
} ;

// ϐ錾 --------------------------------------------------------------

extern GRAPHFILTER_SHADER_HANDLE GraphFilterShaderHandle ;
extern GRAPHFILTER_SYSTEM_DATA GraphFilterSystemData ;
extern float SSAO_Kernel[ /*32*//*18*/64 * 4 ] ;

// ֐vg^Cv錾-----------------------------------------------------------

extern int	GraphFilter_Initialize( void ) ;	// tB^[̏
extern int	GraphFilter_Terminate( void ) ;		// tB^[̌n

extern int	GraphFilter_Mono(            GRAPHFILTER_INFO *Info, float Cb, float Cr ) ;
extern int	GraphFilter_Gauss(           GRAPHFILTER_INFO *Info, int PixelWidth, float Param ) ;
extern int	GraphFilter_Down_Scale(      GRAPHFILTER_INFO *Info, int DivNum ) ;
extern int	GraphFilter_Bright_Clip(     GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor, int IsPMA ) ;
extern int	GraphFilter_Bright_Scale(    GRAPHFILTER_INFO *Info, int BrightMin, int BrightMax, int IsPMA ) ;
extern int	GraphFilter_HSB(             GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright, int IsPMA ) ;
extern int	GraphFilter_Invert(          GRAPHFILTER_INFO *Info, int IsPMA ) ;
extern int	GraphFilter_Level(           GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax, int IsPMA ) ;
extern int	GraphFilter_TwoColor(        GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor, int IsPMA ) ;
extern int	GraphFilter_GradientMap(     GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse, int IsPMA ) ;
extern int	GraphFilter_Replacement(     GRAPHFILTER_INFO *Info, COLOR_U8 TargetColor, COLOR_U8 NextColor, int IsPMA ) ;
extern int	GraphFilter_PremulAlpha(     GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_InterpAlpha(     GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_YUVtoRGB(        GRAPHFILTER_INFO *Info, int UVGrHandle ) ;
extern int	GraphFilter_BicubicScale(    GRAPHFILTER_INFO *Info, int DestSizeX, int DestSizeY ) ;
extern int	GraphFilter_Lanczos3Scale(   GRAPHFILTER_INFO *Info, int DestSizeX, int DestSizeY ) ;
extern int	GraphFilter_SSAO(            GRAPHFILTER_INFO *Info, int DepthMapGrHandle, float KernelRadius, float MinDistance, float MaxDistance, float Strength, int OcclusionColor, float OcclusionPower, int ColorMapGrHandle ) ;
extern int	GraphFilter_FloatColorScale( GRAPHFILTER_INFO *Info, COLOR_F ColorScale, COLOR_F ColorPreSub ) ;

extern int	GraphFilter_RectBltBase( int IsBlend, int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int FilterOrBlendType, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int BlendPosEnable, int BlendX2, int BlendY2, int BlendPos2Enable, int DestX, int DestY, va_list ParamList ) ;

extern int	GraphBlend_Basic(           GRAPHFILTER_INFO *Info, int IsPMA ) ;
extern int	GraphBlend_RGBA_Select_Mix( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA, int IsPMA ) ;



// va_list ֐
extern	int	GraphFilter_VaList(			int    GrHandle,                                                                                                               int FilterType /* DX_GRAPH_FILTER_GAUSS  */ , va_list VaList ) ;		// 摜ɃtB^[s
extern	int	GraphFilterBlt_VaList(		int SrcGrHandle, int DestGrHandle,                                                                                             int FilterType /* DX_GRAPH_FILTER_GAUSS  */ , va_list VaList ) ;		// 摜̃tB^[t]s
extern	int	GraphFilterRectBlt_VaList(	int SrcGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int DestX,  int DestY,                          int FilterType /* DX_GRAPH_FILTER_GAUSS  */ , va_list VaList ) ;		// 摜̃tB^[t]s( `w )
extern	int	GraphBlend_VaList(			int    GrHandle, int BlendGrHandle,                                                                                                                                          int BlendRatio /* uhʂ̉ex( 0:O  255:POO ) */ , int BlendType /* DX_GRAPH_BLEND_ADD  */ , va_list VaList ) ;	// ̉摜uh
extern	int	GraphBlendBlt_VaList(		int SrcGrHandle, int BlendGrHandle, int DestGrHandle,                                                                                                                        int BlendRatio /* uhʂ̉ex( 0:O  255:POO ) */ , int BlendType /* DX_GRAPH_BLEND_ADD  */ , va_list VaList ) ;	// ̉摜uhČʂw̉摜ɏo͂
extern	int	GraphBlendRectBlt_VaList(	int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX,  int BlendY,                             int DestX, int DestY, int BlendRatio /* uhʂ̉ex( 0:O  255:POO ) */ , int BlendType /* DX_GRAPH_BLEND_ADD  */ , va_list VaList ) ;	// ̉摜uhČʂw̉摜ɏo͂( `w )
extern	int	GraphBlendRectBlt2_VaList(	int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX1, int BlendY1, int BlendX2,  int BlendY2, int DestX, int DestY, int BlendRatio /* uhʂ̉ex( 0:O  255:POO ) */ , int BlendType /* DX_GRAPH_BLEND_ADD  */ , va_list VaList ) ;	// ̉摜uhČʂw̉摜ɏo͂( `wAuh摜̋`w )

// ˑ֌W
extern int	GraphFilter_Initialize_PF( void ) ;
extern int	GraphFilter_Terminate_PF( void ) ;

extern int	GraphFilter_Mono_PF(                GRAPHFILTER_INFO *Info, float Cb, float Cr ) ;
extern int	GraphFilter_Gauss_PF(               GRAPHFILTER_INFO *Info, int PixelWidth, float Param, float *Table ) ;
extern int	GraphFilter_Down_Scale_PF(          GRAPHFILTER_INFO *Info, int DivNum ) ;
extern int	GraphFilter_Bright_Clip_PF(         GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor, int IsPMA ) ;
extern int	GraphFilter_Bright_Scale_PF(        GRAPHFILTER_INFO *Info, int BrightMin, int BrightMax, int IsPMA ) ;
extern int	GraphFilter_HSB_PF(                 GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright, int IsPMA ) ;
extern int	GraphFilter_Invert_PF(              GRAPHFILTER_INFO *Info, int IsPMA ) ;
extern int	GraphFilter_Level_PF(               GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax, int IsPMA ) ;
extern int	GraphFilter_TwoColor_PF(            GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor, int IsPMA ) ;
extern int	GraphFilter_GradientMap_PF(         GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse, int IsPMA ) ;
extern int	GraphFilter_Replacement_PF(         GRAPHFILTER_INFO *Info, COLOR_U8 TargetColor, COLOR_U8 NextColor, int IsPMA ) ;
extern int	GraphFilter_PremulAlpha_PF(         GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_InterpAlpha_PF(         GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_YUVtoRGB_PF(            GRAPHFILTER_INFO *Info, int UVGrHandle ) ;
extern int	GraphFilter_BicubicScale_PF(        GRAPHFILTER_INFO *Info, int DestSizeX, int DestSizeY ) ;
extern int	GraphFilter_Lanczos3Scale_PF(       GRAPHFILTER_INFO *Info, int DestSizeX, int DestSizeY ) ;
extern int	GraphFilter_SSAO_PF(                GRAPHFILTER_INFO *Info, int DepthMapGrHandle, float KernelRadius, float MinDistance, float MaxDistance, float Strength, int OcclusionColor, float OcclusionPower, int ColorMapGrHandle ) ;
extern int	GraphFilter_FloatColorScale_PF(     GRAPHFILTER_INFO *Info, COLOR_F ColorScale, COLOR_F ColorPreSub ) ;
extern int	GraphFilter_RectBltBase_Timing0_PF( GRAPHFILTER_INFO *Info, GRAPHFILTER_PARAM *Param ) ;
extern int	GraphFilter_RectBltBase_Timing1_PF( void ) ;
extern int	GraphFilter_DestGraphSetup_PF(      GRAPHFILTER_INFO *Info, int *UseSrcGrHandle, int *UseDestGrHandle ) ;
extern int	GraphFilter_DestGraphUpdate_PF(     GRAPHFILTER_INFO *Info, int UseDestGrHandle, int FilterResult ) ;

extern int	GraphBlend_Basic_PF(                GRAPHFILTER_INFO *Info, int IsPMA ) ;
extern int	GraphBlend_RGBA_Select_Mix_PF(      GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA, int IsPMA ) ;

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_FILTER

#endif // DX_GRAPHICSFILTER_H

