// -------------------------------------------------------------------------------
// 
// 		cwCu		WbCugpR[h@Live2D Cubism4 ֌Wwb_t@C
// 
// 				Ver 3.24e
// 
// -------------------------------------------------------------------------------

/*

	DxUseCLibLive2DCubism4.cpp  Live2D Cubism 4 SDK for Native  Cubism Native Framework y
	Cubism Native Samples x[XƂȂĂāALive2D Open Software License Kp܂B
@@@- Live2D Open Software License 
@@@[{](http://www.live2d.com/eula/live2d-open-software-license-agreement_jp.html)
@@@[English](http://www.live2d.com/eula/live2d-open-software-license-agreement_en.html)

*/

#ifndef DX_USECLIB_LIVE2DCUBISM4_H
#define DX_USECLIB_LIVE2DCUBISM4_H

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifndef DX_NON_LIVE2D_CUBISM4
#include "DxLib.h"
#include "DxHandle.h"
#include "DxThread.h"
#include "DxGraphics.h"
#include "DxBaseFunc.h"
#include "DxStatic.h"

// }N` --------------------------------------------------------------------

// NXE\́E񋓌^` ----------------------------------------------------

class D_CubismMotionQueueManager ;
class D_csmString ;

typedef void ( * csmLogFunctionP )( const char* message ) ;

typedef void( *D_CubismMotionEventFunction )( const D_CubismMotionQueueManager* caller, const D_csmString& eventValue, void* customData ) ;
typedef void* D_CubismMotionQueueEntryHandle ;
extern const D_CubismMotionQueueEntryHandle InvalidMotionQueueEntryHandleValue ;	// ȃ[V̎ʔԍ̒`

// [V̗Dx萔
const int D_CubismMotion_PriorityNone = 0;
const int D_CubismMotion_PriorityIdle = 1;
const int D_CubismMotion_PriorityNormal = 2;
const int D_CubismMotion_PriorityForce = 3;

// J[ufBÕ[h
enum D_CubismBlendMode
{
	D_CubismBlendMode_Normal					= 0,		// ʏ
	D_CubismBlendMode_Additive					= 1,		// Z
	D_CubismBlendMode_Multiplicative			= 2,		// Z
} ;

// [VJ[u̎
enum D_CubismMotionCurveTarget
{
	D_CubismMotionCurveTarget_Model,						// fɑ΂
	D_CubismMotionCurveTarget_Parameter,					// p[^ɑ΂
	D_CubismMotionCurveTarget_PartOpacity					// p[c̕sxɑ΂
} ;

// [VJ[ũZOg̎
enum D_CubismMotionSegmentType
{
	D_CubismMotionSegmentType_Linear			= 0,		// jA
	D_CubismMotionSegmentType_Bezier			= 1,		// xWFȐ
	D_CubismMotionSegmentType_Stepped			= 2,		// Xebv
	D_CubismMotionSegmentType_InverseStepped	= 3			// Co[XXebv
} ;

// Alignment constraints.
enum
{
	D_csmAlignofMoc								= 64,		// Necessary alignment for mocs (in bytes).
	D_csmAlignofModel							= 16		// Necessary alignment for models (in bytes).
} ;

// Bit masks for non-dynamic drawable flags.
enum
{
	D_csmBlendAdditive							= 1 << 0,	// Additive blend mode mask.
	D_csmBlendMultiplicative					= 1 << 1,	// Multiplicative blend mode mask.
	D_csmIsDoubleSided							= 1 << 2,	// Double-sidedness mask.
	D_csmIsInvertedMask							= 1 << 3	// Clipping mask inversion mode mask.
} ;


// Bit masks for dynamic drawable flags.
enum
{
	D_csmIsVisible								= 1 << 0,	// Flag set when visible.
	D_csmVisibilityDidChange					= 1 << 1,	// Flag set when visibility did change.
	D_csmOpacityDidChange						= 1 << 2,	// Flag set when opacity did change.
	D_csmDrawOrderDidChange						= 1 << 3,	// Flag set when draw order did change.
	D_csmRenderOrderDidChange					= 1 << 4,	// Flag set when render order did change.
	D_csmVertexPositionsDidChange				= 1 << 5,	// Flag set when vertex positions did change.
	D_csmBlendColorDidChange					= 1 << 6	// Flag set when blend color did change.
} ;

// moc3 file format version.
enum
{
	D_csmMocVersion_Unknown						= 0,		// unknown
	D_csmMocVersion_30							= 1,		// moc3 file version 3.0.00 - 3.2.07
	D_csmMocVersion_33							= 2,		// moc3 file version 3.3.00 -
	D_csmMocVersion_40							= 3,		// moc3 file version 4.0.00 -
	D_csmMocVersion_42							= 4,		// moc3 file version 4.2.00 -
} ;

enum
{
	D_csmParameterType_Normal					= 0,		// Normal parameter
	D_csmParameterType_BlendShape				= 1			// Parameter for blend shape
} ;

// xWFJ[ủߕ@̃tO^Cv
enum D_EvaluationOptionFlag
{
	D_EvaluationOptionFlag_AreBeziersRistricted	= 0,		// xWFnh̋K
} ;

typedef int D_csmParameterType ;

#define CSM_STRING_SMALL_LENGTH					64
#define CSM_MAP_DEFAULT_SIZE					10
#define CSM_IDMANAGER_MAX_ID_NUM				65536


// ``(WEfloatl)`NX
class D_csmRectF
{
public:
	D_csmRectF() ;																			// RXgN^
	D_csmRectF( float x, float y, float w, float h ) ;										// tRXgN^
	virtual ~D_csmRectF() ;																	// fXgN^
	float						GetCenterX() const { return X + 0.5f * Width; }				// `XW擾
	float						GetCenterY() const { return Y + 0.5f * Height; }			// `YW擾
	float						GetRight() const { return X + Width; }						// E[XW擾
	float						GetBottom() const { return Y + Height; }					// [YW擾
	void						SetRect( D_csmRectF* r ) ;									// `ɒlZbg
	void						Expand( float w, float h ) ;								// `ɂďcgk

	float						X ;							// [XW
	float						Y ;							// [YW
	float						Width ;						// 
	float						Height ;					// 
} ;

// 2xNg^
struct D_CubismVector2
{
	float X ;          // X̒l
	float Y ;          // Y̒l

	D_CubismVector2() : X( 0.0f ), Y( 0.0f ){}														// RXgN^
	D_CubismVector2( float x, float y ) : X( x ), Y( y ){}											// fXgN^
	friend D_CubismVector2		operator+( const D_CubismVector2& a, const D_CubismVector2& b ) ;	// xNg̉Z
	friend D_CubismVector2		operator-( const D_CubismVector2& a, const D_CubismVector2& b ) ;	// xNǧZ
	friend D_CubismVector2		operator*( const D_CubismVector2& vector, const float scalar ) ;	// xNg̏ZixNglƃXJ[lj
	friend D_CubismVector2		operator*( const float scalar, const D_CubismVector2& vector ) ;	// xNg̏ZiXJ[lƃxNglj
	friend D_CubismVector2		operator/( const D_CubismVector2& vector, const float scalar ) ;	// xNg̏ZixNglƃXJ[lj
	const D_CubismVector2&		operator+=( const D_CubismVector2& rhs ) ;							// Z
	const D_CubismVector2&		operator-=( const D_CubismVector2& rhs ) ;							// Z
	const D_CubismVector2&		operator*=( const D_CubismVector2& rhs ) ;							// ZixNglj
	const D_CubismVector2&		operator/=( const D_CubismVector2& rhs ) ;							// ZixNglj
	const D_CubismVector2&		operator*=( const float scalar ) ;									// ZiXJ[lj
	const D_CubismVector2&		operator/=( const float scalar ) ;									// ZiXJ[lj
	bool						operator==( const D_CubismVector2& rhs ) const ;					// ̊mFiHj
	bool						operator!=( const D_CubismVector2& rhs ) const ;					// ̊mFiȂHj
	void						Normalize() ;														// K̓Kp
	float						GetLength() const ;													// xNg̒̎擾
	float						GetDistanceWith( D_CubismVector2 a ) const ;						// xNg̋̎擾
	float						Dot( const D_CubismVector2& a ) const ;								// hbgς̌vZ
} ;

// 4xNg^
struct D_CubismVector4
{
	float X ;          // X̒l
	float Y ;          // Y̒l
	float Z ;          // Z̒l
	float W ;          // W̒l
} ;

// Utility functions for csmVector2.
D_CubismVector2					operator+( const D_CubismVector2& a, const D_CubismVector2& b ) ;
D_CubismVector2					operator-( const D_CubismVector2& a, const D_CubismVector2& b ) ;
D_CubismVector2					operator*( const D_CubismVector2& vector, const float scalar ) ;
D_CubismVector2					operator*( const float scalar, const D_CubismVector2& vector ) ;
D_CubismVector2					operator/( const D_CubismVector2& vector, const float scalar ) ;

// lvZȂǂɎgp郆[eBeBNX
class D_CubismMath
{
public:
	static const float Pi;
	static float RangeF( float value, float min, float max ) ;								// ̒lŏlƍől͈̔͂Ɏ߂lԂ
#ifndef DX_NON_NAMESPACE
	static float SinF( float x ){ float Sin, Cos ; DxLib::_SINCOS( x, &Sin, &Cos ) ; return Sin ; }// TC֐̒l߂
	static float CosF( float x ){ float Sin, Cos ; DxLib::_SINCOS( x, &Sin, &Cos ) ; return Cos ; }// RTC֐̒l߂
	static float SqrtF( float x ){ return DxLib::_SQRT( x ) ; }									// ([g)߂
#else // DX_NON_NAMESPACE
	static float SinF( float x ){ float Sin, Cos ; _SINCOS( x, &Sin, &Cos ) ; return Sin ; }// TC֐̒l߂
	static float CosF( float x ){ float Sin, Cos ; _SINCOS( x, &Sin, &Cos ) ; return Cos ; }// RTC֐̒l߂
	static float SqrtF( float x ){ return _SQRT( x ) ; }									// ([g)߂
#endif // DX_NON_NAMESPACE
	static float AbsF( float x ){ return x < 0.0f ? -x : x ; }								// Βl̒l߂
	static float GetEasingSine( float value ) ;												// C[WOꂽTC߂	
	static float Max( float l, float r ){ return ( l > r ) ? l : r ; }						// 傫̒lԂ
	static float Min( float l, float r ){ return ( l > r ) ? r : l ; }						// ̒lԂB
	static float DegreesToRadian( float degrees ) ;											// pxlWAlɕϊ܂B
	static float RadianToDegrees( float radian ) ;											// WAlpxlɕϊ܂B
	static float DirectionToRadian( D_CubismVector2 from, D_CubismVector2 to ) ;			// 2̃xNg烉WAl߂܂B
	static float DirectionToDegrees( D_CubismVector2 from, D_CubismVector2 to ) ;			// 2̃xNgpxl߂܂B
	static D_CubismVector2 RadianToDirection( float totalAngle ) ;							// WAlxNgɕϊ܂B

private:
	// privateRXgN^
	D_CubismMath() ;
} ;

// NX
class D_csmString
{
public:
	D_csmString() ;																			// RXgN^
	D_csmString( const D_csmString& s ) ;													// tRXgN^
	D_csmString( const BYTE/*wchar_t*/ * c ) ;												// tRXgN^
	D_csmString( const char * c ) ;															// tRXgN^
	D_csmString( const char * c, int length ) ;												// tRXgN^
	D_csmString( const char * c, int length, bool usePtr ) ;								// tRXgN^
	virtual ~D_csmString() ;																// fXgN^
	D_csmString&				operator=( const char* c ) ;								// =Zq̃I[o[[h( D_csmString^ )
	bool						operator==( const D_csmString& s ) const ;					// ==Zq̃I[o[[h( D_csmString^ )
	bool						operator==( const char* c ) const ;							// ==Zq̃I[o[[h( char^ )
	D_csmString					operator+( const D_csmString& s ) const ;					// +Zq̃I[o[[h(D_csmString^)
	D_csmString					operator+( const char* c ) const ;							// +Zq̃I[o[[h(char^)
	D_csmString&				operator+=( const D_csmString& s ) ;						// +=Zq̃I[o[[h(D_csmString^)
	D_csmString&				operator+=( const char* c ) ;								// +=Zq̃I[o[[h(char^)
	D_csmString&				Append( const char* c, int length ) ;						// ɒǉ
	D_csmString&				Append( int length, const char v ) ;						// TCYgĕ𖄂߂
	const char *				GetRawString() const ;										// CꕶƂẴ|C^擾
	const char *				GetRawStringA() ;											// CꕶƂẴ|C^擾( cwCu̖߂lp )
	const BYTE/*wchar_t*/ *		GetRawStringW() ;											// CꕶƂẴ|C^擾( wchar_tp )

protected:
	void						Initialize( const char* c, int length, bool usePtr ) ;		// D_csmStringCX^X̏֐B̃ZbgƃnbVR[h̎ZosB
	int							Copy( const BYTE/*wchar_t*/ * c, int length ) ;				// Rs[. I[\0ǉ
	int							Copy( const char* c, int length ) ;							// Rs[. I[\0ǉ
	int							CalcHashcode( const char* c, int length ) ;					// 񂩂nbVl𐶐ĕԂ
	void						Clear() ;													// |C^

private:
	bool						IsEmpty() const ;											// 񂪋󂩂ǂH
	void						SetEmpty() ;												// ɐݒ
	char *						WritePointer() ;											// CꕶƂẴ|C^擾

	char *						_ptr ;						// ^z̃|C^
	int							_length ;					// pimۂ͍Ō0邽_length+1j
	int							_hashcode ;					// CX^XɓĂꂽnbVl
	char						_small[ 64 ] ;				// ̒64-1̏ꍇ͂gp

	bool						_enableA ;					// cwCu̖߂lp̃f[^Lǂ
	char *						_ptrA ;						// ^z̃|C^( cwCu̖߂lp )
	int							_lengthA ;					// pimۂ͍Ō0邽_length+1j( cwCu̖߂lp )
	char						_smallA[ 64 ] ;				// ̒64-1̏ꍇ͂gp( cwCu̖߂lp )

	bool						_enableW ;					// wchar_t p̃f[^Lǂ
	BYTE/*wchar_t*/ *			_ptrW ;						// ^z̃|C^( wchar_tp )
	int							_lengthW ;					// pimۂ͍Ō0邽_length+1j( wchar_tp )
	DWORD/*wchar_t*/			_smallW[ 64 ] ;				// ̒64-1̏ꍇ͂gp( wchar_tp )
} ;

// NX( wchar_t )
class D_csmStringW
{
public:
	D_csmStringW() ;																		// RXgN^
	D_csmStringW( const BYTE/*wchar_t*/ * c ) ;												// tRXgN^
	D_csmStringW( const char* c ) ;															// tRXgN^
	D_csmStringW( const BYTE/*wchar_t*/ * c, int length ) ;									// tRXgN^
	D_csmStringW( const D_csmStringW& s ) ;													// tRXgN^
	D_csmStringW( const BYTE/*wchar_t*/ * c, int length, bool usePtr ) ;						// tRXgN^
	virtual ~D_csmStringW() ;																// fXgN^
	D_csmStringW&				operator=( const D_csmStringW& s ) ;						// =Zq̃I[o[[h(D_csmStringW^)
	D_csmStringW&				operator=( const BYTE/*wchar_t*/ * c ) ;					// =Zq̃I[o[[h(wchar_t^)
	bool						operator==( const D_csmStringW& s ) const ;					// ==Zq̃I[o[[h(D_csmStringW^)
	bool						operator==( const BYTE/*wchar_t*/ * c ) const ;				// ==Zq̃I[o[[h(wchar_t^)
	bool						operator<( const D_csmStringW& s ) const ;					// <Zq̃I[o[[h(D_csmStringW^)
	bool						operator<( const BYTE/*wchar_t*/ * c ) const ;				// <Zq̃I[o[[h(wchar_t^)
	bool						operator>( const D_csmStringW& s ) const ;					// >Zq̃I[o[[h(D_csmStringW^)
	bool						operator>( const BYTE/*wchar_t*/ * c ) const ;				// >Zq̃I[o[[h(wchar_t^)
	D_csmStringW				operator+( const D_csmStringW& s ) const ;					// +Zq̃I[o[[h(D_csmStringW^)
	D_csmStringW				operator+( const BYTE/*wchar_t*/ * c ) const ;				// +Zq̃I[o[[h(wchar_t^)
	D_csmStringW&				operator+=( const D_csmStringW& s ) ;						// +=Zq̃I[o[[h(D_csmStringW^)
	D_csmStringW&				operator+=( const BYTE/*wchar_t*/ * c ) ;					// +=Zq̃I[o[[h(wchar_t^)
	D_csmStringW&				Append( const BYTE/*wchar_t*/ * c, int length ) ;			//  ɒǉ
	D_csmStringW&				Append( int length, const DWORD/*wchar_t*/ v ) ;			// TCYgĕ𖄂߂
	int							GetLength() const { return _length; }						// ̒Ԃ
	const BYTE/*wchar_t*/ *		GetRawString() const ;										// CꕶƂẴ|C^擾
	void						Clear() ;													// |C^
	int							GetHashcode() ;												// nbVR[h擾

protected:
	void						Copy( const BYTE/*wchar_t*/ * c, int length ) ;				// Rs[. I[\0ǉ
	void						Copy( const char* c, int length ) ;							// Rs[. I[\0ǉ
	void						Initialize( const BYTE/*wchar_t*/ * c, int length, bool usePtr ) ;	// D_csmStringWCX^X̏֐B̃ZbgƃnbVR[h̎ZosB
	int							CalcHashcode( const BYTE/*wchar_t*/ * c, int length ) ;				// 񂩂nbVl𐶐ĕԂ

private:
	static int					s_totalInstanceNo ;			// ʎZ̃CX^Xԍ
	BYTE/*wchar_t*/ *			_ptr ;						// ^z̃|C^
	int							_length ;					// pimۂ͍Ō0邽_length+1j
	int							_hashcode ;					// CX^XɓĂꂽnbVl
	int							_instanceNo ;				// CX^XɊ蓖Ăꂽԍ
	DWORD/*wchar_t*/ 			_small[ CSM_STRING_SMALL_LENGTH ] ;	// ̒CSM_STRING_SMALL_LENGTH-1̏ꍇ͂gp 

	bool						IsEmpty() const ;											// 񂪋󂩂ǂH
	void						SetEmpty() ;												// ɐݒ
	BYTE/*wchar_t*/ *			WritePointer() ;											// CꕶƂẴ|C^擾
} ;

class D_CubismIdManager ;

// p[^Ep[cEDrawableێ
struct D_CubismId
{
	friend class D_CubismIdManager ;

	D_csmString&				GetString() { return _id ; }								// ID擾

private:
	D_CubismId(){}																			// RXgN^
	D_CubismId( const char* id ){ _id = id ; }												// RXgN^
	D_CubismId( const D_CubismId& c ) : _id( c._id ) {}
	~D_CubismId(){}																			// fXgN^
	D_CubismId&					operator=( const D_CubismId& c ){ if( this != &c ){ _id = c._id ; } return *this ; }
	bool						operator==( const D_CubismId& c ) const { return ( _id == c._id ) ; }
	bool						operator!=( const D_CubismId& c ) const { return !( _id == c._id ) ; }

	D_csmString					_id ;														// ID
} ;

typedef D_CubismId * D_CubismIdHandle ;

// xN^[^iϔz^j
template< class T >
class D_csmVector
{
public :
	D_csmVector() ;																			// RXgN^
	D_csmVector( int initialCapacity, bool zeroClear = false ) ;							// tRXgN^
	D_csmVector( const D_csmVector& c ){ Copy( c ) ; }										// Rs[RXgN^
	virtual ~D_csmVector() ;																	// fXgN^

	T*							GetPtr(){ return _ptr ; }									// Rei̐擪AhXԂ
	T&							operator[]( int index ){ return _ptr[ index ]; }			// []Zq̃I[o[[h
	const T&					operator[]( int index ) const { return _ptr[ index ]; }		// []Zq̃I[o[[h( const)
	T&							At( int index ){ return _ptr[ index ] ;	}					// CfbNXŎw肵vfԂ
	void						PushBack( const T& value, bool callPlacementNew = true ) ;	// PushBack.ReiɐVȗvfǉB
	void						Clear() ;													// ReȋSvf
	unsigned int				GetSize() const { return _size ; }							// Rei̗vfԂ
	void						Resize( int size, T value = T() ){ UpdateSize( size, value, true ) ; }	// vector#resize()ɑTCYύX
	void						UpdateSize( int size, T value = T(), bool callPlacementNew = true ) ;	// vector#resize()ɑTCYύX
	void						PrepareCapacity( int newSize ) ;							// ReĩLpVeBmۂ

	class iterator ;			// D_csmVector<T>̃Ce[^̑O錾

	void						Insert( iterator position, iterator begin, iterator end, bool callPlacementNew = true ) ;		// ReiɃReivf}
	void						Assign( int newSize, T value = T(), bool callPlacementNew = true ) ;							// ReȋSvfɑ΂đsB
	bool						Remove( int index ) ;										// ReiCfbNXŎw肵vf폜

	// D_csmVector<T>̃Ce[^
	class iterator
	{
		// D_csmVector<T>thNXƂ
		friend class D_csmVector ;

	public :
		iterator() : _index( 0 ) , _vector( NULL ){}										// RXgN^
		iterator( D_csmVector< T > *v ) : _index( 0 ), _vector( v ){}						// tRXgN^
		iterator( D_csmVector< T > *v, int idx ) : _index( idx ), _vector( v ){}			// tRXgN^
		iterator&				operator=( const iterator& ite ){ _index = ite._index ; _vector = ite._vector ; return *this ; }	// =Zq̃I[o[[h
		iterator&				operator++(){ ++_index ; return *this ; }					// Ou++Zq̃I[o[[h
		iterator&				operator--(){ --_index ; return *this ; }					// Ou--Zq̃I[o[[h
		iterator				operator++( int ){ iterator iteold( _vector, _index++ ) ; return iteold ; }	// u++Zq̃I[o[[h( int͌up̃_~[)
		iterator				operator--( int ){ iterator iteold( _vector, _index-- ) ; return iteold ; }	// u--Zq̃I[o[[h( int͌up̃_~[)
		T&						operator*() const{ return _vector->_ptr[ _index ] ; }		// *Zq̃I[o[[h
		bool					operator!=( const iterator& ite ) const { return ( _index != ite._index ) || ( _vector != ite._vector ) ; }	// !=Zq̃I[o[[h

	public :
		int						_index ;					// ReĩCfbNXl
		D_csmVector< T >		*_vector ;					// Rei̎Q
	} ;

	//D_csmVector<T>̃Ce[^iconstj
	class const_iterator
	{
		// D_csmVector<T>thNXƂ
		friend class D_csmVector ;

	public :
		const_iterator() : _index( 0 ), _vector( NULL ){}									// RXgN^
		const_iterator( const D_csmVector< T >* v ) : _index( 0 ), _vector( v ){}			// tRXgN^
		const_iterator( const D_csmVector< T >* v, int idx ) : _index( idx ), _vector( v ){}	// tRXgN^
		const_iterator&			operator=( const const_iterator& ite ){ _index = ite._index ; _vector = ite._vector ; return *this ; }	// =Zq̃I[o[[h
		const_iterator&			operator++(){ ++_index ; return *this ; }					// Ou++Zq̃I[o[[h
		const_iterator&			operator--(){ --_index ; return *this ;	}					// Ou--Zq̃I[o[[h
		const_iterator			operator++( int ){ const_iterator iteold( _vector, _index++ ) ; return iteold ; }	// u++Zq̃I[o[[h( int͌up̃_~[)
		const_iterator			operator--( int ){ const_iterator iteold( _vector, _index-- ) ; return iteold ; }	// u--Zq̃I[o[[h( int͌up̃_~[)
		T&						operator*() const { return _vector->_ptr[ _index] ; }		// *Zq̃I[o[[h
		bool					operator!=( const const_iterator& ite ) const { return ( _index != ite._index ) || ( _vector != ite._vector ) ; }	// !=Zq̃I[o[[h

	public:
		int						_index ;					// ReĩCfbNXl
		const D_csmVector< T >	*_vector ;					// Reĩ|C^
	} ;

	const iterator				Begin(){ iterator ite( this, 0 ) ; return ite ; }			// Rei̐擪vfԂ
	const iterator				End(){ iterator ite( this, _size ) ; return ite ; }			// ReȉI[vfԂ
	const const_iterator		Begin() const { const_iterator ite( this, 0 ) ; return ite ; }	// Rei̐擪vfԂ
	const const_iterator		End() const { const_iterator ite( this, _size ) ; return ite ; }	// ReȉI[vfԂ
	const iterator				Erase( const iterator& ite )								// Reivf폜đ̗vfVtg
	{
		int index = ite._index ;
		if( index < 0 || _size <= index ) return ite ;
		if( index < _size - 1 ) _MEMMOVE( &( _ptr[ index ] ), &( _ptr[ index + 1 ] ), sizeof( T ) * ( _size - index - 1 ) ) ;
		--_size ;
		iterator ite2( this, index ) ;
		return ite2 ;
	}
	const const_iterator		Erase( const const_iterator& ite )							// Reivf폜đ̗vfVtg
	{
		int index = ite._index ;
		if( index < 0 || _size <= index ) return ite ;
		if( index < _size - 1 ) _MEMMOVE( &( _ptr[ index ] ), &( _ptr[ index + 1 ] ), sizeof( T ) * ( _size - index - 1 ) ) ;
		--_size ;
		const_iterator ite2( this, index ) ;
		return ite2 ;
	}

	D_csmVector&				operator=( const D_csmVector& c ){ if( this != &c ){ Clear() ; Copy( c ) ; } return *this ; }	// Rs[RXgN^

public:
	void						Copy( const D_csmVector& c ) ;	// D_csmVector<T>̃Rs[֐

	T*							_ptr ;						// Rei̐擪AhXi|C^j
	int							_size ;						// Rei̗vfiTCYj
	int							_capacity ;					// ReĩLpVeB
} ;

// Key-D_JsonValuẽyA`NX
template< class _KeyT, class _ValT >
class D_csmPair
{
public:
	D_csmPair() : First(), Second() {}														// RXgN^
	D_csmPair( const _KeyT& key ) : First( key ), Second() {}								// tRXgN^
	D_csmPair( const _KeyT& key, const _ValT& value ) : First( key ), Second( value ) {}	// tRXgN^
	virtual ~D_csmPair() {}																	// fXgN^

	_KeyT						First ;						// KeyƂėpϐ
	_ValT						Second ;					// D_JsonValueƂėpϐ
} ;

// }bv^
template< class _KeyT, class _ValT >
class D_csmMap
{
public:
	D_csmMap() ;																			// RXgN^
	D_csmMap( int size ) ;																	// tRXgN^
	virtual ~D_csmMap() ;																	// fXgN^
	void						AppendKey( _KeyT& key ) ;									// L[ǉ
	_ValT&						operator[]( _KeyT key ) ;									// YZq[key]̃I[o[[h
	const _ValT&				operator[]( _KeyT key ) const ;								// YZq[key]̃I[o[[h( const)
	bool						IsExist( _KeyT key ) ;										// œnKeyvf݂邩
	void						Clear() ;													// Key-D_JsonValuẽ|C^Sĉ
	int							GetSize() const { return _size ; }							// ReĩTCY擾
	void						PrepareCapacity( int newSize, bool fitToSize ) ;			// ReĩLpVeBmۂ

	// D_csmMap<T>̃Ce[^
	class iterator
	{
		// D_csmMap<T>thNXƂ
		friend class D_csmMap;

	public:
		iterator() : _index( 0 ), _map( NULL ){}											// RXgN^
		iterator( D_csmMap< _KeyT, _ValT >* v ) : _index( 0 ), _map( v ){}					// tRXgN^
		iterator( D_csmMap< _KeyT, _ValT >* v, int idx ) : _index( idx ), _map( v ) {}		// tRXgN^
		iterator&				operator=( const iterator& ite ){ _index = ite._index ; _map = ite._map ; return *this ; }	// =Zq̃I[o[[h
		iterator&				operator++(){ _index++ ; return *this ; }					// Ou++Zq̃I[o[[h
		iterator&				operator--(){ _index-- ; return *this ; }					// Ou--Zq̃I[o[[h
		iterator				operator++( int ){ iterator iteold( _map, _index++ ) ; return iteold ; }	// u++Zq̃I[o[[h( int͌up̃_~[)
		iterator				operator--( int ){ iterator iteold( _map, _index-- ) ; return iteold ; }	// u--Zq̃I[o[[h( int͌up̃_~[)
		D_csmPair< _KeyT, _ValT >& operator*() const { return _map->_keyValues[ _index ] ; }	// *Zq̃I[o[[h
		bool					operator!=( const iterator& ite ) const { return ( _index != ite._index ) || ( _map != ite._map ) ;	}	// !=Zq̃I[o[[h

	private:
		int						_index ;					// ReĩCfbNXl
		D_csmMap< _KeyT, _ValT >* _map ;					// Reĩ|C^
	} ;

	// D_csmMap<T>̃Ce[^( const)
	class const_iterator
	{
		// D_csmMap<T>thNXƂ
		friend class D_csmMap;

	public:
		const_iterator() : _index( 0 ), _map( NULL ) {}										// RXgN^
		const_iterator( const D_csmMap< _KeyT, _ValT >* v ) : _index( 0 ), _map( v ) {}		// tRXgN^
		const_iterator( const D_csmMap< _KeyT, _ValT >* v, int idx ) : _index( idx ), _map( v ) {}	// tRXgN^
		const_iterator&			operator=( const const_iterator& ite ){ _index = ite._index ; _map = ite._map ; return *this ; }	// =Zq̃I[o[[h
		const_iterator&			operator++(){ ++_index ; return *this ; }					// Ou++Zq̃I[o[[h
		const_iterator&			operator--(){ --_index ; return *this ; }					// Ou--Zq̃I[o[[h
		const_iterator			operator++( int ){ const_iterator iteold( _map, _index++ ) ; return iteold ; }	// u++Zq̃I[o[[h( int͌up̃_~[)
		const_iterator			operator--( int ){ const_iterator iteold( _map, _index-- ) ; return iteold ; }	// u--Zq̃I[o[[h( int͌up̃_~[)
		D_csmPair< _KeyT, _ValT >* operator->() const { return &_map->_keyValues[ _index ] ; }	// ->Zq̃I[o[[h
		D_csmPair< _KeyT, _ValT >& operator*() const { return _map->_keyValues[ _index ] ; }	// *Zq̃I[o[[h
		bool					operator!=( const const_iterator& ite ) const { return ( _index != ite._index ) || ( _map != ite._map ) ; }	// !=Zq̃I[o[[h

	private:
		int						_index ;					// ReĩCfbNXl
		const D_csmMap< _KeyT, _ValT >* _map ;				// Reĩ|C^( const)
	} ;

	const const_iterator		Begin() const { const_iterator ite( this, 0 ) ; return ite ; }	// Rei̐擪vfԂ
	const const_iterator		End() const { const_iterator ite( this, _size ) ; return ite ; }	// ReȉI[vfԂ
	const iterator				Erase( const iterator& ite )								// Reivf폜
	{
		int index = ite._index ;
		if( index < 0 || _size <= index ) return ite ;
		if( index < _size - 1 )
			_MEMMOVE( &( _keyValues[ index ] ), &( _keyValues[ index + 1 ] ), sizeof( D_csmPair< _KeyT, _ValT > ) * ( _size - index - 1 ) ) ;
		--_size ;
		iterator ite2( this, index ) ;
		return ite2 ;
	}
	const const_iterator		Erase( const const_iterator& ite )							// Reivf폜
	{
		int index = ite._index ;
		if( index < 0 || _size <= index ) return ite ;
		if( index < _size - 1 )
			_MEMMOVE( &( _keyValues[ index ] ), &( _keyValues[ index + 1 ] ), sizeof( D_csmPair< _KeyT, _ValT > ) * ( _size - index - 1 ) ) ;
		--_size ;
		const_iterator ite2( this, index ) ;
		return ite2 ;
	}

public:
	D_csmPair< _KeyT, _ValT > *	_keyValues ;				// Key-D_JsonValueyA̔z
	_ValT *						_dummyValuePtr ;			// ̒lԂ߂̃_~[(statictemplte邽߃oƂj
	int							_size ;						// Rei̗vfiTCYj
	int							_capacity ;					// ReĩLpVeB
} ;

// ID̊Ǘ
class D_CubismIdManager
{
	friend struct D_CubismId ;

public:
	D_CubismIdManager() ;																	// RXgN^
	~D_CubismIdManager() ;																	// fXgN^
	void						RegisterIds( const char** ids, int count ) ;				// IDXgo^
	void						RegisterIds( const D_csmVector< D_csmString >& ids ) ;		// IDXgo^
	D_CubismId *				RegisterId( const char* id ) ;								// IDo^
	D_CubismId *				RegisterId( const D_csmString& id ) ;						// IDo^
	D_CubismId *				GetId( const D_csmString& id ) ;							// IDID擾
	D_CubismId *				GetId( const char* id ) ;									// IDID擾
	D_CubismId *				FindId( const char* id ) const ;							// IDID
	bool						IsExist( const D_csmString& id ) const ;					// IDID̊mF
	bool						IsExist( const char* id ) const ;							// IDID̊mF

private:
	D_CubismIdManager( const D_CubismIdManager& ) ;
	D_CubismIdManager& operator=( const D_CubismIdManager& ) ;

	D_CubismId *				_ids[ CSM_IDMANAGER_MAX_ID_NUM ] ;							// o^ĂID̃Xg
	volatile int				_idNum ;													// o^ĂID̐
#ifndef DX_NON_NAMESPACE
	DxLib::DX_CRITICAL_SECTION	_criticalSection ;											// NeBJZNV
#else // DX_NON_NAMESPACE
	DX_CRITICAL_SECTION			_criticalSection ;											// NeBJZNV
#endif // DX_NON_NAMESPACE
} ;

class D_JsonValue ;
class D_JsonError ;
class D_JsonNullValue ;

#define D_CSM_JSON_ERROR_TYPE_MISMATCH            "D_JsonError:type mismatch"
#define D_CSM_JSON_ERROR_INDEX_OUT_OF_BOUNDS      "D_JsonError:index out of bounds"

// p[XJSONGg̗vf̊NX
class D_JsonValue
{
	friend class D_JsonArray ;

public:
	static D_JsonValue*			ErrorValue ;				// ꎞIȕԂlƂĕԂG[BCubismFramework::Dispose()܂łCSM_DELETEȂB
	static D_JsonValue*			NullValue ;					// ꎞIȕԂlƂĕԂNULLBCubismFramework::Dispose()܂łCSM_DELETEȂB
	D_JsonValue() {}																		// RXgN^
	virtual ~D_JsonValue() {}																// fXgN^
	virtual D_csmString&		GetString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) = 0 ;// vf𕶎ŕԂ(D_csmString^)
	virtual const char*			GetRawString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;// vf𕶎ŕԂ(char*)
	virtual const char*			GetRawStringA( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;// vf𕶎ŕԂ(cwCup)
	virtual const BYTE/*wchar_t*/ *	GetRawStringW( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;// vf𕶎ŕԂ(wchar_t*)
	virtual int					ToInt( int defaultValue = 0 ) { return defaultValue ; }			// vf𐔒l^ŕԂ( int)
	virtual float				ToFloat( float defaultValue = 0.0f ) { return defaultValue ; }	// vf𐔒l^ŕԂ(float)
	virtual bool				ToBoolean( bool defaultValue = false ) { return defaultValue ; }	// vf^UlŕԂ( bool)
	virtual int					GetSize() { return 0; }											// vf^UlŕԂ( bool)
	virtual D_csmVector<D_JsonValue*>*				GetVector( D_csmVector<D_JsonValue*>* defaultValue = NULL ) { return defaultValue ; }		// vfReiŕԂ(D_csmVector<D_JsonValue*>)
	virtual D_csmMap<D_csmString, D_JsonValue*>*	GetMap( D_csmMap<D_csmString, D_JsonValue*>* defaultValue = NULL ) { return defaultValue ; }	// vf}bvŕԂ(D_csmMap<D_csmString, D_JsonValue*>)
	virtual D_csmVector<D_csmString>&				GetKeys(){ return *s_dummyKeys ; }															// }bṽL[ꗗReiŕԂ
	virtual D_JsonValue&		operator[]( int index )	;									// YZq[int]
	virtual D_JsonValue&		operator[]( const D_csmString& string )	;					// YZq[D_csmString]
	virtual D_JsonValue&		operator[]( const char* s )	;								// YZq[char*]
	virtual bool				IsError() { return false ; }								// D_JsonValue̎ނG[lȂtrueB
	virtual bool				IsNull() { return false ; }									// D_JsonValue̎ނNULLlȂtrueB
	virtual bool				IsBool() { return false ; }									// D_JsonValue̎ނ^UlȂtrueB
	virtual bool				IsFloat() { return false ; }								// D_JsonValue̎ނl^ȂtrueB
	virtual bool				IsString() { return false ; }								// D_JsonValue̎ނȂtrueB
	virtual bool				IsArray() { return false ; }								// D_JsonValue̎ނzȂtrueB
	virtual bool				IsMap() { return false ; }									// D_JsonValue̎ނ}bv^ȂtrueB
	virtual bool				Equals( const D_csmString& /*value*/ ) { return false ; }	// ̒lƓtrueB
	virtual bool				Equals( const char* /*value*/ ) { return false ; }			// ̒lƓtrueB
	virtual bool				Equals( int /*value*/ ) { return false ; }					// ̒lƓtrueB
	virtual bool				Equals( float /*value*/ ) { return false ; }				// ̒lƓtrueB
	virtual bool				Equals( bool /*value*/ ) { return false ; }					// ̒lƓtrueB
	virtual bool				IsStatic() { return false ; }								// D_JsonValue̒lÓIȂtrue. ÓIȂȂ
	virtual D_JsonValue*		SetErrorNotForClientCall( const char* /*errorStr*/ ) { return ErrorValue ; }// D_JsonValueɃG[lZbg

	static void					StaticInitializeNotForClientCall() ;							//  p\bh
	static void					StaticReleaseNotForClientCall() ;							// [Xp\bh
protected:
	D_csmString					_stringBuffer ;				// obt@

private:
	static D_csmVector<D_csmString>* s_dummyKeys ;			// _~[L[
} ;

// AsciîݑΉŏ̌yJSONp[TB
class D_CubismJson
{
public:
	static D_CubismJson*		Create( const BYTE* buffer, size_t size ) ;					// oCgf[^璼ڃ[hăp[X
	static void					Delete( D_CubismJson* instance ) ;							// p[XJSONIuWFNg̉
	D_JsonValue&				GetRoot() const ;											// p[XJSOÑ[gvf̃|C^Ԃ
	const char*					GetParseError() const { return _error ; }					// p[X̃G[lԂ
	bool						CheckEndOfFile() const { return ( *_root )[ 1 ].Equals( "EOF" ) ; }// [gvf̗̎vft@C̏I[trueԂ

protected:
	bool ParseBytes( const BYTE* buffer, int size ) ;// JSOÑp[Xs
	D_csmString ParseString( const char* string, int length, int begin, int* outEndPos ) ;	// ́u"v܂ł̕p[XB͊OŉKvB
	D_JsonValue* ParseObject( const char* buffer, int length, int begin, int* outEndPos ) ;	// JSOÑIuWFNgGgp[XD_JsonValueIuWFNgԂ
	D_JsonValue* ParseArray( const char* buffer, int length, int begin, int* outEndPos ) ;	// JSON̔zGgp[XD_JsonValueIuWFNgԂ
	D_JsonValue* ParseValue( const char* buffer, int length, int begin, int* outEndPos ) ;	// JSONGgD_JsonValue(float,D_JsonString,D_JsonValue*,D_JsonArray,null,true,false)p[XGg̏ɉēParseString(), ParseObject(), ParseArray()Ă

private:
	D_CubismJson() ;																			// RXgN^
	D_CubismJson( const BYTE* buffer, int length ) ;											// tRXgN^
	virtual ~D_CubismJson() ;																// fXgN^

	const char*					_error ;						// p[X̃G[
	int							_lineCount ;					// G[񍐂ɗpsJEg
	D_JsonValue*				_root ;						// p[Xꂽ[gvf
} ;

// p[XJSON̗vfDoublelƂĈ
class D_JsonFloat : public D_JsonValue
{
public:
	D_JsonFloat( float v ) : D_JsonValue() { this->_value = v; }							// RXgN^
	virtual ~D_JsonFloat() {}																// fXgN^
	virtual bool				IsFloat() { return true ; }									// D_JsonValue̎ނl^ȂtrueB
	virtual D_csmString&		GetString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;	// vf𕶎ŕԂ(D_csmString^)
	virtual int					ToInt( int /*defaultValue*/ = 0 ) { return static_cast< int >( this->_value ) ; }	// vf𐔒l^ŕԂ( int)
	virtual float				ToFloat( float /*defaultValue*/ = 0 ) { return this->_value ; }						// vf𐔒l^ŕԂ(float)
	virtual bool				Equals( float v ) { return v == this->_value ; }			// ̒lƓtrue
	virtual bool				Equals( const D_csmString& /*v*/ ) { return false ; }		// ̒lƓtrue
	virtual bool				Equals( const char* /*v*/ ) { return false ; }				// ̒lƓtrue
	virtual bool				Equals( int /*v*/ ) { return false ; }						// ̒lƓtrue
	virtual bool				Equals( bool /*v*/ ) { return false ; }						// ̒lƓtrue

private:
	float						_value ;						// JSONvf̒l
} ;

// p[XJSON̗vf^UlƂĈ
class D_JsonBoolean : public D_JsonValue
{
	friend class D_JsonValue ;

public:
	static D_JsonBoolean*		TrueValue ; // true
	static D_JsonBoolean*		FalseValue ;// false
	virtual ~D_JsonBoolean() {}																// fXgN^
	virtual bool				IsBool() { return true ; }									// D_JsonValue̎ނ^UlȂtrueB
	virtual bool				ToBoolean( bool /*defaultValue = false*/ ) { return _boolValue ; }// vf^UlŕԂ( bool)
	virtual D_csmString&		GetString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;// vf𕶎ŕԂ(D_csmString^)
	virtual bool				Equals( bool v ) { return v == _boolValue ; }				// ̒lƓtrueB
	virtual bool				Equals( const D_csmString& /*v*/ ) { return false ; }		// ̒lƓtrueB
	virtual bool				Equals( const char* /*v*/ ) { return false ; }				// ̒lƓtrueB
	virtual bool				Equals( int /*v*/ ) { return false ; }						// ̒lƓtrueB
	virtual bool				Equals( float /*v*/ ) { return false ; }					// ̒lƓtrueB
	virtual bool				IsStatic() { return true ; }								// D_JsonValue̒lÓIȂtrue. ÓIȂȂ

private:
	D_JsonBoolean( bool v ) : D_JsonValue() { this->_boolValue = v; }						// tRXgN^
	bool						_boolValue ;					// JSONvf̒l
} ;

// p[XJSON̗vf𕶎ƂĈ
class D_JsonString : public D_JsonValue
{
public:
	D_JsonString( const D_csmString& s ) : D_JsonValue() { this->_stringBuffer = s ; }		// tRXgN^
	D_JsonString( const char* s ) : D_JsonValue() { this->_stringBuffer = s ; }				// tRXgN^
	virtual ~D_JsonString() {}																// fXgN^
	virtual bool				IsString() { return true ; }									// D_JsonValue̎ނȂtrueB
	virtual D_csmString&		GetString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;// vf𕶎ŕԂ(D_csmString^)
	virtual bool				Equals( const D_csmString& v ) { return ( _stringBuffer == v ) ; }// ̒lƓtrueB
	virtual bool				Equals( const char* v ) { return ( _stringBuffer == v ) ; }	// ̒lƓtrueB
	virtual bool				Equals( int /*v*/ ) { return false ; }						// ̒lƓtrueB
	virtual bool				Equals( float /*v*/ ) { return false ; }					// ̒lƓtrueB
	virtual bool				Equals( bool /*v*/ ) { return false ; }						// ̒lƓtrueB
} ;

// JSONp[X̃G[ʁB^̂悤ɐU镑
class D_JsonError : public D_JsonString
{
	friend class D_JsonValue ; //
	friend class D_JsonArray ; //
	friend class D_CubismJson ; //

public:
	virtual bool				IsStatic() { return _isStatic ; }							// D_JsonValue̒lÓIȂtrue. ÓIȂȂ
	virtual D_JsonValue*		SetErrorNotForClientCall( const char* s ){ _stringBuffer = s ; return this ; }	//  G[Zbg

protected:
	D_JsonError( const D_csmString& s, bool isStatic ) : D_JsonString( s ), _isStatic( isStatic ) {}// tRXgN^
	virtual ~D_JsonError() {}																// fXgN^
	virtual bool				IsError() { return true ; }									// D_JsonValue̎ނG[lȂtrueB

	bool						_isStatic ;					// ÓID_JsonValueǂ
} ;

// p[XJSON̗vfNulllƂĎ
class D_JsonNullValue : public D_JsonValue
{
	friend class D_JsonValue ; //
	friend class D_CubismJson ; //

public:
	virtual ~D_JsonNullValue() {}															// fXgN^
	virtual bool IsNull() { return true ; }													// D_JsonValue̎ނNULLlȂtrueB
	virtual D_csmString& GetString( const D_csmString& /*defaultValue = ""*/, const D_csmString& /*indent = ""*/ ){ return _stringBuffer ; }	// vf𕶎ŕԂ(D_csmString^)
	virtual bool IsStatic() { return true ; }												// D_JsonValue̒lÓIȂtrue. ÓIȂȂ

private:
	D_JsonNullValue() : D_JsonValue() { _stringBuffer = "D_JsonNullValue"; }				//  RXgN^
} ;

// p[XJSON̗vfzƂĎ
class D_JsonArray : public D_JsonValue
{
public:
	D_JsonArray() : D_JsonValue(), _array() {}												//  RXgN^
	virtual ~D_JsonArray() ;																// fXgN^
	virtual bool				IsArray() { return true ; }									// D_JsonValue̎ނzȂtrueB
	virtual D_JsonValue&		operator[]( int index ) ;									// YZq[int]
	virtual D_JsonValue&		operator[]( const D_csmString& string ) ;					// YZq[D_csmString]
	virtual D_JsonValue&		operator[]( const char* s ) ;								// YZq[char*]
	virtual D_csmString&		GetString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;// vf𕶎ŕԂ(D_csmString^)
	void						Add( D_JsonValue* v ) { _array.PushBack( v, false ) ; }		// zvfǉ
	virtual D_csmVector<D_JsonValue*>* GetVector( D_csmVector<D_JsonValue*>* /*defaultValue = NULL*/ ) { return &_array ; }// vfReiŕԂ(D_csmVector<D_JsonValue*>)
	virtual int					GetSize() { return static_cast< int >( _array.GetSize() ) ; }// vf̐Ԃ

private:
	D_csmVector<D_JsonValue*>	_array ;						// JSONvf̒l
} ;

// p[XJSON̗vf}bvƂĎ
class D_JsonMap : public D_JsonValue
{
public:
	D_JsonMap() : D_JsonValue(), _keys( NULL ) {}											//  RXgN^
	virtual ~D_JsonMap() ;																	//  fXgN^
	virtual bool				IsMap() { return true ; }									//  D_JsonValue̒lD_JsonMap^Ȃtrue
	virtual D_JsonValue&		operator[]( const D_csmString& s ) ;						// YZq[D_csmString]
	virtual D_JsonValue&		operator[]( const char* s ) ;								// YZq[char*]
	virtual D_JsonValue&		operator[]( int index ) ;									// YZq[int]
	virtual D_csmString&		GetString( const D_csmString& defaultValue = "", const D_csmString& indent = "" ) ;
	void						Put( D_csmString& key, D_JsonValue* v ) ;					// D_JsonMapɗvfǉ
	virtual int					GetSize() { return static_cast< int >( _keys->GetSize() ) ; }// D_JsonMap̗vf擾
	virtual D_csmMap<D_csmString, D_JsonValue*>* GetMap( D_csmMap<D_csmString, D_JsonValue*>* defaultValue = NULL ) ;//  vfD_JsonMap^ŕԂ
	virtual D_csmVector<D_csmString>& GetKeys() ;											//  D_JsonMapL[̃Xg擾

private:
	D_csmMap<D_csmString, D_JsonValue*>	_map;		// JSONvf̒l
	D_csmVector<D_csmString>*			_keys ;		// JSONvf̒l
} ;

// motion3.jsoñReiB
class D_CubismMotionJson
{
public:
	D_CubismMotionJson( const BYTE* buffer, size_t size ) ;									// RXgN^
	virtual ~D_CubismMotionJson() ;															// fXgN^
	float						GetMotionDuration() const ;									// [V̒̎擾
	bool						IsMotionLoop() const ;										// [Ṽ[v̎擾
	bool						GetEvaluationOptionFlag( int flagType ) const ;				// [ṼxWFJ[ủߕ̃tO擾
	int							GetMotionCurveCount() const ;								// [VJ[ǔ̎擾
	float						GetMotionFps() const ;										// [Ṽt[[g̎擾
	int							GetMotionTotalSegmentCount() const ;						// [ṼZOg̑v̎擾
	int							GetMotionTotalPointCount() const ;							// [ṼJ[u̐_̑v̎擾
	bool						IsExistMotionFadeInTime() const ;							// [ṼtF[hCԂ̑
	bool						IsExistMotionFadeOutTime() const ;							// [ṼtF[hAEgԂ̑
	float						GetMotionFadeInTime() const ;								// [ṼtF[hCԂ̎擾
	float						GetMotionFadeOutTime() const ;								// [ṼtF[hAEgԂ̎擾
	const char*					GetMotionCurveTarget( int curveIndex ) const ;				// [ṼJ[u̎ނ̎擾
	D_CubismIdHandle			GetMotionCurveId( int curveIndex ) ;						// [ṼJ[uID̎擾
	bool						IsExistMotionCurveFadeInTime( int curveIndex ) const ;		// [ṼJ[ũtF[hCԂ̑
	bool						IsExistMotionCurveFadeOutTime( int curveIndex ) const ;		// [ṼJ[ũtF[hAEgԂ̑
	float						GetMotionCurveFadeInTime( int curveIndex ) const ;			// [ṼJ[ũtF[hCԂ̎擾
	float						GetMotionCurveFadeOutTime( int curveIndex ) const ;			// [ṼJ[ũtF[hAEgԂ̎擾
	int							GetMotionCurveSegmentCount( int curveIndex ) const ;		// [ṼJ[ũZOǧ̎擾
	float						GetMotionCurveSegment( int curveIndex, int segmentIndex ) const ;// [ṼJ[ũZOg̒l̎擾
	int							GetEventCount() const ;										// Cxǧ̎擾
	int							GetTotalEventValueSize() const ;							// Cxg̑̎擾
	float						GetEventTime( int userDataIndex ) const ;					// Cxg̎Ԃ̎擾
	const char*					GetEventValue( int userDataIndex ) const ;					// Cxg̎擾

private:
	static const char*			Meta ;
	static const char*			Duration ;
	static const char*			Loop ;
	static const char*			AreBeziersRestricted ;
	static const char*			CurveCount ;
	static const char*			Fps ;
	static const char*			TotalSegmentCount ;
	static const char*			TotalPointCount ;
	static const char*			Curves ;
	static const char*			Target ;
	static const char*			Id ;
	static const char*			FadeInTime ;
	static const char*			FadeOutTime ;
	static const char*			Segments ;
	static const char*			UserData ;
	static const char*			UserDataCount ;
	static const char*			TotalUserDataSize ;
	static const char*			Time ;
	static const char*			Value ;
	D_CubismJson*				_json ;      // motion3.jsonf[^
} ;

// [VJ[u̐_
struct D_CubismMotionPoint
{
	float						Time ;						// [b]
	float						Value ;						// l
} ;

// [VJ[ũZOg
struct D_CubismMotionSegment
{
    float						( *Evaluate )( const D_CubismMotionPoint *points, float time ) ;	// gp]֐
	int							BasePointIndex ;			// ŏ̃ZOgւ̃CfbNX
	int							SegmentType ;				// ZOg̎
} ;

// [VJ[uB
struct D_CubismMotionCurve
{
	D_CubismMotionCurveTarget	Type ;						// J[u̎
	D_CubismIdHandle			Id ;						// J[uID
	int							SegmentCount ;				// ZOǧ
	int							BaseSegmentIndex ;			// ŏ̃ZOg̃CfbNX
	float						FadeInTime ;				// tF[hCɂ鎞[b]
	float						FadeOutTime ;				// tF[hAEgɂ鎞[b]
} ;

// CxgB
struct D_CubismMotionEvent
{
	float						FireTime ;
	D_csmString					Value ;
} ;

// [Vf[^B
struct D_CubismMotionData
{
	float						Duration ;					// [V̒[b]
	short						Loop ;						// [v邩ǂ
	short						CurveCount ;				// J[ǔ
	int							EventCount ;				// UserDatǎ
	float						Fps ;						// t[[g

	D_csmVector< D_CubismMotionCurve >		Curves ;		// J[ũXg
	D_csmVector< D_CubismMotionSegment >	Segments ;		// ZOg̃Xg
	D_csmVector< D_CubismMotionPoint >		Points ;		// |Cg̃Xg
	D_csmVector< D_CubismMotionEvent >		Events ;		// Cxg̃Xg
} ;

class D_CubismModel ;

// Mocf[^̊Ǘ
class D_CubismMoc
{
	friend class D_CubismModel ;
public:
	static D_CubismMoc*			Create( const BYTE* mocBytes, size_t size ) ;				// obt@Mocf[^̍쐬
	static void					Delete( D_CubismMoc* moc ) ;								// Mocf[^폜
	D_CubismModel*				CreateModel() ;												// f쐬
	void						DeleteModel( D_CubismModel* model ) ;						// f폜

private:
	D_CubismMoc( void* moc ) ;																// RXgN^
	virtual ~D_CubismMoc() ;																// fXgN^

	void *						_moc ;						// Mocf[^
	int							_modelCount ;				// Mocf[^ꂽf̌
} ;

//  O錾
class D_CubismModel ;

// 4x4̍s
class D_CubismMatrix44
{
public:
	D_CubismMatrix44() ;																	// RXgN^
	virtual ~D_CubismMatrix44() ;															// fXgN^
	static void					Multiply( float* a, float* b, float* dst ) ;				// Z
	void						LoadIdentity() ;											// Pʍsɏ
	float*						GetArray() ;												// s𕂓_̔zŎ擾
	void						SetMatrix( float* tr ) ;									// sݒ
	float						GetScaleX() const ;											// X̊g嗦擾
	float						GetScaleY() const ;											// Y̊g嗦擾
	float						GetTranslateX() const ;										// Ẍړʂ擾
	float						GetTranslateY() const ;										// Ÿړʂ擾
	float						TransformX( float src ) ;									// X̒l݂̍sŌvZ
	float						TransformY( float src ) ;									// Y̒l݂̍sŌvZ
	float						InvertTransformX( float src ) ;								// X̒l݂̍sŋtvZ
	float						InvertTransformY( float src ) ;								// Y̒l݂̍sŋtvZ
	void						TranslateRelative( float x, float y ) ;						// ݂̍s̈ʒuN_ɂĈړ
	void						Translate( float x, float y ) ;								// ݂̍s̈ʒuړ
	void						TranslateX( float x ) ;										// ݂̍sẌʒuړ
	void						TranslateY( float y ) ;										// ݂̍sŸʒuړ
	void						ScaleRelative( float x, float y ) ;							// ݂̍s̊g嗦𑊑ΓIɐݒ
	void						Scale( float x, float y ) ;									// ݂̍s̊g嗦ݒ
	void						RotateRelative( float angle ) ;								// ݂̍s̉]( WA )𑊑ΓIɐݒ
	void						MultiplyByMatrix( D_CubismMatrix44* m ) ;					// ݂̍sɍsZ

protected:
	float						_tr[ 16 ] ;					// 4x4sf[^
} ;

// f`郌_
class D_CubismRenderer
{
public:
	// eNX`̐FRGBAň߂̍\
	struct CubismTextureColor
	{
		CubismTextureColor() : R( 1.0f ), G( 1.0f ), B( 1.0f ), A( 1.0f ) {} ;				// RXgN^
		CubismTextureColor( float r, float g, float b, float a )							// RXgN^
		: R( r )
		, G( g )
		, B( b )
		, A( a ) {};

		virtual ~CubismTextureColor() {} ;													// fXgN^

		float					R ;							// ԃ`l
		float					G ;							// ΃`l
		float					B ;							// `l
		float					A ;							// `l
	} ; // CubismTextureColor
	static D_CubismRenderer*	Create() ;													// _̃CX^X𐶐Ď擾
	static void					Delete( D_CubismRenderer* renderer ) ;						// _̃CX^X
	static void					StaticRelease() ;											// _ێÓIȃ\[X
	virtual void				Initialize( D_CubismModel* model, int ASyncThread ) ;		// _̏s
	void						DrawModel() ;												// f`悷
	void						SetMvpMatrix( D_CubismMatrix44* matrix4x4 ) ;				// Model-View-Projection sZbg
	D_CubismMatrix44			GetMvpMatrix() const ;										// Model-View-Projection s擾
	void						SetModelColor( float red, float green, float blue, float alpha ) ;	// f̐FZbgB
	CubismTextureColor			GetModelColor() const ;										// f̐F擾B
	void						IsPremultipliedAlpha( bool enable ) ;						//  Zς̗݃LEZbgB
	bool						IsPremultipliedAlpha() const ;								//  Zς̗݃LE擾B
	void						IsCulling( bool culling ) ;									//  JOiЖʕ`j̗LEZbgB
	bool						IsCulling() const ;											//  JOiЖʕ`j̗LE擾B
	void						SetAnisotropy( float anisotropy ) ;							// eNX`ٕ̈tB^Õp[^Zbg
	float						GetAnisotropy() const ;										// eNX`ٕ̈tB^Õp[^Zbg
	D_CubismModel*				GetModel() const ;											// _O郂f擾B
	void						UseHighPrecisionMask( bool high ) ;							// }XN`̕ύXB
	bool						IsUsingHighPrecisionMask() ;								// }XN`̕擾B

protected:
	D_CubismRenderer() ;																	// RXgN^
	virtual ~D_CubismRenderer() ;															// fXgN^
	virtual void				DoDrawModel() = 0 ;											// f`̎
	virtual void				DrawMesh( int textureNo, int indexCount, int vertexCount, WORD* indexArray, float* vertexArray, float* uvArray, float opacity, D_CubismBlendMode colorBlendMode, bool invertedMask ) = 0 ;	// `IuWFNgiA[gbVj`悷B
	virtual void				SaveProfile() = 0 ;											// f`撼Õ_̃Xe[gێ
	virtual void				RestoreProfile() = 0 ;										// f`撼Õ_̃Xe[g𕜋A

private:
	// Rs[RXgN^B
	D_CubismRenderer( const D_CubismRenderer& ) ;
	D_CubismRenderer&			operator=( const D_CubismRenderer& ) ;

	D_CubismMatrix44			_mvpMatrix4x4 ;				// Model-View-Projection s
	CubismTextureColor			_modelColor ;				// f̂̃J[(RGBA)
	bool						_isCulling ;				// JOLȂtrue
	bool						_isPremultipliedAlpha ;		// Zς݃Ȃtrue
	float						_anisotropy ;				// eNX`ٕ̈tB^Õp[^
	D_CubismModel*				_model ;					// _OΏۂ̃f
	bool						_useHighPrecisionMask ;		// falsȅꍇA}XNZ߂ĕ`悷 truȅꍇA}XN̓p[c`悲Ƃɏ 
} ;

// f
class D_CubismModel
{
	friend class D_CubismMoc ;
public:

	// eNX`̐FRGBAň߂̍\
	struct DrawableColorData
	{
		DrawableColorData() : IsOverwritten( false ) , Color() {};		// RXgN^
		DrawableColorData( bool isOverwritten, D_CubismRenderer::CubismTextureColor color ) : IsOverwritten( isOverwritten ), Color( color ) {};	// RXgN^
		virtual ~DrawableColorData() {};								// fXgN^

		bool IsOverwritten ;
		D_CubismRenderer::CubismTextureColor Color ;
	} ;

	// eNX`̃JOݒǗ邽߂̍\
	struct DrawableCullingData
	{
		DrawableCullingData() : IsOverwritten( false ), IsCulling( 0 ) {} ;	// RXgN^
		DrawableCullingData( bool isOverwritten, int isCulling ) : IsOverwritten( isOverwritten ), IsCulling( isCulling ) {} ;	// RXgN^
		virtual ~DrawableCullingData() {} ;								// fXgN^

		bool IsOverwritten ;
		int IsCulling ;
	} ;

	// eNX`̐FRGBAň߂̍\
	struct PartColorData
	{
		PartColorData()	: IsOverwritten( false ) , Color() {} ;			// RXgN^
		PartColorData( bool isOverwritten, D_CubismRenderer::CubismTextureColor color )	: IsOverwritten( isOverwritten ) , Color( color ) {} ;	// RXgN^
		virtual ~PartColorData() {} ;									// fXgN^

		bool IsOverwritten ;
		D_CubismRenderer::CubismTextureColor Color ;
	} ;

	void						Update() const ;											// f̃p[^̍XV
	float						GetCanvasWidthPixel() const ;								// LoX̕擾
	float						GetCanvasHeightPixel() const ;								// LoX̍擾
	float						GetPixelsPerUnit() const ;									// PixelsPerUnit擾
	float						GetCanvasWidth() const ;									// LoX̎̕擾
	float						GetCanvasHeight() const ;									// LoX̍̎擾
	void						GetCanvasInfo( D_CubismVector2 *SizeInPixels, D_CubismVector2 *OriginInPixels, float *PixelsPerUnit ) ;		// LoX̏擾
	int							GetPartIndex( D_CubismIdHandle partId ) ;					// p[c̃CfbNX̎擾
	D_CubismIdHandle			GetPartId( int partIndex ) ;								// p[cID擾
	int							GetPartCount() const ;										// p[č̎擾
	void						SetPartOpacity( D_CubismIdHandle partId, float opacity ) ;	// p[c̕sx̐ݒ
	void						SetPartOpacity( int partIndex, float opacity ) ;			// p[c̕sx̐ݒ
	float						GetPartOpacity( D_CubismIdHandle partId ) ;					// p[c̕sx̎擾
	float						GetPartOpacity( int partIndex ) ;							// p[c̕sx̎擾
	int							GetParameterIndex( D_CubismIdHandle parameterId ) ;			// p[^̃CfbNX̎擾
	int							GetParameterCount() const ;									// p[^̌̎擾
	D_CubismIdHandle			GetParameterId( int parameterIndex ) ;						// p[^ID̎擾
	D_csmParameterType			GetParameterType( DWORD parameterIndex ) const ;				// p[^̎ނ̎擾
	float						GetParameterMaximumValue( DWORD parameterIndex ) const ;	// p[^̍ől̎擾
	float						GetParameterMinimumValue( DWORD parameterIndex ) const ;	// p[^̍ŏl̎擾
	float						GetParameterDefaultValue( DWORD parameterIndex ) const ;	// p[^̃ftHgl̎擾
	float						GetParameterValue( D_CubismIdHandle parameterId ) ;			// p[^̒l̎擾
	float						GetParameterValue( int parameterIndex ) ;					// p[^̒l̎擾
	void						SetParameterValue( D_CubismIdHandle parameterId, float value, float weight = 1.0f, bool force = false ) ;	// p[^̒l̐ݒ
	void						SetParameterValue( int parameterIndex, float value, float weight = 1.0f, bool force = false ) ;				// p[^̒l̐ݒ
	void						SetDisableChangeParameter( D_CubismIdHandle parameterId, bool isDisable ) ;	// p[^̒l̕ύX𖳌邩ǂݒ肷
	void						SetDisableChangeParameter( int parameterIndex, bool isDisable ) ;			// p[^̒l̕ύX𖳌邩ǂݒ肷
	void						AddParameterValue( D_CubismIdHandle parameterId, float value, float weight = 1.0f ) ;	// p[^̒l̉Z
	void						AddParameterValue( int parameterIndex, float value, float weight = 1.0f ) ;				// p[^̒l̉Z
	void						MultiplyParameterValue( D_CubismIdHandle parameterId, float value, float weight = 1.0f ) ;	// p[^̒l̏Z
	void						MultiplyParameterValue( int parameterIndex, float value, float weight = 1.0f ) ;		// p[^̒l̏Z
	int							GetDrawableIndex( D_CubismIdHandle drawableId ) const ;		// DrawablẽCfbNX̎擾
	int							GetDrawableCount() const ;									// Drawablě̎擾
	D_CubismIdHandle			GetDrawableId( int drawableIndex ) const ;					// DrawableID̎擾
	const int *					GetDrawableRenderOrders() const ;							// Drawable̕`揇Xg̎擾
	int							GetDrawableTextureIndex( int drawableIndex ) const ;		// DrawablẽeNX`CfbNX̎擾
	int							GetDrawableVertexIndexCount( int drawableIndex ) const ;	// Drawable̒_CfbNX̌̎擾
	int							GetDrawableVertexCount( int drawableIndex ) const ;			// Drawable̒_̌̎擾
	const float *				GetDrawableVertices( int drawableIndex ) const ;			// Drawable̒_Xg̎擾
	const WORD *				GetDrawableVertexIndices( int drawableIndex ) const ;		// Drawable̒_CfbNXXg̎擾
	const D_CubismVector2 *		GetDrawableVertexPositions( int drawableIndex ) const ;		// Drawable̒_Xg̎擾
	const D_CubismVector2 *		GetDrawableVertexUvs( int drawableIndex ) const ;			// Drawable̒_UVXg̎擾
	float						GetDrawableOpacity( int drawableIndex ) const ;				// Drawable̕sx̎擾
	D_CubismVector4				GetDrawableMultiplyColor( int drawableIndex ) const ;		// DrawablȅZF̎擾
	D_CubismVector4				GetDrawableScreenColor( int drawableIndex ) const ;			// DrawablẽXN[F̎擾
	int							GetDrawableParentPartIndex( DWORD drawableIndex ) const ;	// Drawable̐ep[c̃CfbNX̎擾
	D_CubismBlendMode			GetDrawableBlendMode( int drawableIndex ) const ;			// Drawablẽuh[h̎擾
	bool						GetDrawableInvertedMask( int drawableIndex ) const ;		// Drawablẽ}XN̔]gp̎擾
	bool						GetDrawableDynamicFlagIsVisible( int drawableIndex ) const ;	// Drawable̕\̎擾
	bool						GetDrawableDynamicFlagVisibilityDidChange( int drawableIndex ) const ;	// Drawable̕\Ԃ̕ω̎擾
	bool						GetDrawableDynamicFlagOpacityDidChange( int drawableIndex ) const ;	// Drawable̕sx̕ω̎擾
	bool						GetDrawableDynamicFlagDrawOrderDidChange( int drawableIndex ) const ;	// DrawableDrawOrder̕ω̎擾
	bool						GetDrawableDynamicFlagRenderOrderDidChange( int drawableIndex ) const ;	// Drawable̕`揇̕ω̎擾
	bool						GetDrawableDynamicFlagVertexPositionsDidChange( int drawableIndex ) const ;	// DrawableVertexPositions̕ω̎擾
	bool						GetDrawableDynamicFlagBlendColorDidChange( int drawableIndex ) const ;	// DrawablȅZFEXN[F̕ω̎擾
	const int**					GetDrawableMasks() const ;									// DrawablẽNbsO}XNXg̎擾
	const int*					GetDrawableMaskCounts() const ;								// DrawablẽNbsO}XŇXg̎擾
	bool						IsUsingMasking() const ;									// NbsO}XN̎gp
	void						LoadParameters() ;											// ۑꂽp[^̓ǂݍ
	void						SaveParameters() ;											// p[^̕ۑ
	D_CubismRenderer::CubismTextureColor GetMultiplyColor( int drawableIndex ) const ;		// drawablȅZF擾
	D_CubismRenderer::CubismTextureColor GetScreenColor( int drawableIndex ) const ;		// drawablẽXN[F擾
	void						SetMultiplyColor( int drawableIndex, const D_CubismRenderer::CubismTextureColor& color ) ;	// drawablȅZFݒ肷
	void						SetMultiplyColor( int drawableIndex, float r, float g, float b, float a = 1.0f ) ;			// drawablȅZFݒ肷
	void						SetScreenColor( int drawableIndex, const D_CubismRenderer::CubismTextureColor& color ) ;	// drawablẽXN[Fݒ肷
	void						SetScreenColor( int drawableIndex, float r, float g, float b, float a = 1.0f ) ;			// drawablẽXN[Fݒ肷
	D_CubismRenderer::CubismTextureColor GetPartMultiplyColor( int partIndex ) const ;		// part̏ZF擾
	D_CubismRenderer::CubismTextureColor GetPartScreenColor( int partIndex ) const ;		// part̏ZF擾
	void						SetPartMultiplyColor( int partIndex, const D_CubismRenderer::CubismTextureColor& color ) ;	// part̃XN[Fݒ肷
	void						SetPartMultiplyColor( int partIndex, float r, float g, float b, float a = 1.0f ) ;			// part̏ZFݒ肷
	void						SetPartScreenColor( int partIndex, const D_CubismRenderer::CubismTextureColor& color ) ;	// part̃XN[Fݒ肷
	void						SetPartScreenColor( int partIndex, float r, float g, float b, float a = 1.0f ) ;			// part̃XN[Fݒ肷
	bool						GetOverwriteFlagForModelMultiplyColors() const ;								// SDK烂fŜ̏ZF㏑邩B
	bool						GetOverwriteFlagForModelScreenColors() const ;									// SDK烂fŜ̃XN[F㏑邩B
	void						SetOverwriteFlagForModelMultiplyColors( bool value ) ;							// SDK烂fŜ̏ZF㏑邩Zbg
	void						SetOverwriteFlagForModelScreenColors( bool value ) ;							// SDK烂fŜ̃XN[F㏑邩Zbg  SDK̐FgȂtrueAf̐FgȂfalse
	bool						GetOverwriteFlagForDrawableMultiplyColors( int drawableIndex ) const ;			// SDKdrawablȅZF㏑邩B
	bool						GetOverwriteFlagForDrawableScreenColors( int drawableIndex ) const ;			// SDKdrawablẽXN[F㏑邩B
	void						SetOverwriteFlagForDrawableMultiplyColors( DWORD drawableIndex, bool value ) ;	// SDKdrawablȅZF㏑邩Zbg
	void						SetOverwriteFlagForDrawableScreenColors( DWORD drawableIndex, bool value ) ;	// SDKdrawablẽXN[F㏑邩Zbg
	bool						GetOverwriteColorForPartMultiplyColors( int partIndex ) const ;					// SDKpart̏ZF㏑邩B
	bool						GetOverwriteColorForPartScreenColors( int partIndex ) const ;					// SDKpart̃XN[F㏑邩B
	void						SetOverwriteColorForPartMultiplyColors( DWORD partIndex, bool value ) ;			// SDKpart̏ZF㏑邩Zbg     SDK̐FgȂtrueAf̐FgȂfalse
	void						SetOverwriteColorForPartScreenColors( DWORD partIndex, bool value ) ;			// SDKpart̃XN[F㏑邩Zbg      SDK̐FgȂtrueAf̐FgȂfalse
	int							GetDrawableCulling( int drawableIndex ) const ;									// DrawablẽJO̎擾
	void						SetDrawableCulling( int drawableIndex, int isCulling ) ;						// DrawablẽJOݒ肷
	bool						GetOverwriteFlagForModelCullings() const ;										// SDK烂fŜ̃JOݒ㏑邩B
	void						SetOverwriteFlagForModelCullings( bool value ) ;								// SDK烂fŜ̃JOݒ㏑邩Zbg  SDK̃JOݒgȂtrueAf̃JOݒgȂfalse
	bool						GetOverwriteFlagForDrawableCullings( int drawableIndex ) const ;				// SDKdrawablẽJOݒ㏑邩B
	void						SetOverwriteFlagForDrawableCullings( DWORD drawableIndex, bool value ) ;		// SDKdrawablẽJOݒ㏑邩Zbg  SDK̃JOݒgȂtrueAf̃JOݒgȂfalse
	float						GetModelOpacity() ;																// f̕sx擾
	void						SetModelOpacity( float value ) ;												// f̕sxݒ肷
	void*						GetModel() const ;

private:
	D_CubismModel( void* model ) ;															// RXgN^
	virtual ~D_CubismModel() ;																// fXgN^
	D_CubismModel( const D_CubismModel& ) ;

	D_CubismModel&				operator=( const D_CubismModel& ) ;
	void						Initialize() ;												// 

	// partOverwriteColor Set֐
	void SetPartColor(
		DWORD partIndex,
		float r, float g, float b, float a,
		D_csmVector< PartColorData >& partColors,
		D_csmVector< DrawableColorData >& drawableColors ) ;

	// partOverwriteFlag Set֐
	void SetOverwriteColorForPartColors(
		DWORD partIndex,
		bool value,
		D_csmVector< PartColorData >& partColors,
		D_csmVector< DrawableColorData >& drawableColors ) ;

	D_csmMap< int, float >				_notExistPartOpacities ;	// ݂ĂȂp[c̕sx̃Xg
	D_csmMap< D_CubismIdHandle, int >	_notExistPartId ;			// ݂ĂȂp[cID̃Xg
	D_csmMap< int, float >				_notExistParameterValues ;	// ݂ĂȂp[^̒l̃Xg
	D_csmMap< D_CubismIdHandle, int >	_notExistParameterId ;		// ݂ĂȂp[^ID̃Xg
	D_csmVector< int >					_disableChangeParameterIndices ;	// ʏ̕ύX͋ۂp[^ԍ
	D_csmVector< float >				_savedParameters ;			// ۑꂽp[^
	void *								_model ;					// f
	float *								_parameterValues ;			// p[^̒l̃Xg
	const float *						_parameterMaximumValues ;	// p[^̍ől̃Xg
	const float *						_parameterMinimumValues ;	// p[^̍ŏl̃Xg
	float *								_partOpacities ;			// p[c̕sx̃Xg
    float								_modelOpacity ;				// f̕sx
	D_csmVector< D_CubismIdHandle >		_parameterIds ;
	D_csmVector< D_CubismIdHandle >		_partIds ;
	D_csmVector< D_CubismIdHandle >		_drawableIds ;
	D_csmVector< DrawableColorData >	_userScreenColors;			// Drawable ZF̔z
	D_csmVector< DrawableColorData >	_userMultiplyColors;		// Drawable XN[F̔z
	D_csmVector< DrawableCullingData >	_userCullings;				// JOݒ̔z
	D_csmVector< PartColorData >		_userPartScreenColors;		// Part ZF̔z
	D_csmVector< PartColorData >		_userPartMultiplyColors;	// Part XN[F̔z
	D_csmVector< D_csmVector< DWORD > >	_partChildDrawables;		// Part̎qDrawableIndex̔z
	bool								_isOverwrittenModelMultiplyColors; // ZFSď㏑邩H
	bool								_isOverwrittenModelScreenColors; // XN[FSď㏑邩H
	bool								_isOverwrittenCullings;		// f̃JOݒׂď㏑邩H
} ;

// D_CubismMotionQueueManagerōĐĂe[V̊Ǘ
class D_CubismMotionQueueEntry
{
	friend class D_CubismMotionQueueManager ;
	friend class D_ACubismMotion ;
	friend class D_CubismMotion ;

public:
	D_CubismMotionQueueEntry() ;															// RXgN^
	virtual ~D_CubismMotionQueueEntry() ;// fXgN^
	void						StartFadeout( float fadeOutSeconds, float userTimeSeconds ) ;	// tF[hAEg̊Jn
	bool						IsFinished() const ;										// [V̏I̊mF
	bool						IsStarted() const ;											// [V̊Jn̊mF
	float						GetStartTime() const ;										// [V̊Jn̎擾
	float						GetFadeInStartTime() const ;								// tF[hC̊Jn̎擾
	float						GetEndTime() const ;										// tF[hC̏I̎擾
	void						SetStartTime( float startTime ) ;							// [V̊Jn̐ݒ
	void						SetFadeInStartTime( float startTime ) ;						// tF[hC̊Jn̐ݒ
	void						SetEndTime( float endTime )	;								// tF[hC̏I̐ݒ
	void						IsFinished( bool f ) ;										// [V̏I̐ݒ
	void						IsStarted( bool f ) ;										// [V̊Jn̐ݒ
	bool						IsAvailable() const ;										// [V̗L̊mF
	void						IsAvailable( bool v ) ;										// [V̗L̐ݒ
	void						SetState( float timeSeconds, float weight ) ;				// [V̏Ԃ̐ݒ
	float						GetStateTime() const ;										// [V̌ݎ̎擾
	float						GetStateWeight() const ;									// [V̏d݂̎擾
	float						GetLastCheckEventTime() const ;								// ŌɃCxg̔΂`FbNԂ擾
	void						SetLastCheckEventTime( float checkTime ) ;					// ŌɃCxg`FbNԂݒ

private:
	bool						_autoDelete ;					// 폜
	class D_ACubismMotion*		_motion ;						// [V
	bool						_available ;					// LtO
	bool						_finished ;						// ItO
	bool						_started ;						// JntOi0.9.00ȍ~j
	float						_startTimeSeconds ;				//  [VĐJn[b]
	float						_fadeInStartTimeSeconds ;		//  tF[hCJni[v̎͏̂݁j[b]
	float						_endTimeSeconds ;				// I\莞[b]
	float						_stateTimeSeconds ;				//  ̏[b]
	float						_stateWeight ;					//  d݂̏
	float						_lastEventCheckSeconds ;		//   ŏIMotioñ`FbN
	D_CubismMotionQueueEntryHandle  _motionQueueEntryHandle	;	// CX^XƂɈӂ̒lʔԍ
} ;

// [VĐ̊Ǘ
class D_CubismMotionQueueManager
{
public:
	D_CubismMotionQueueManager() ;															// RXgN^
	virtual ~D_CubismMotionQueueManager() ;													// fXgN^
	D_CubismMotionQueueEntryHandle StartMotion( D_ACubismMotion* motion, bool autoDelete, float userTimeSeconds ) ;		// w肵[V̊Jn
	bool						IsFinished() ;																			// ׂẴ[V̏I̊mF
	bool						IsFinished( D_CubismMotionQueueEntryHandle motionQueueEntryNumber ) ;					// w肵[V̏I̊mF
	void						StopAllMotions() ;																		// ׂẴ[V̒~
	D_CubismMotionQueueEntry *	GetCubismMotionQueueEntry( D_CubismMotionQueueEntryHandle motionQueueEntryNumber ) ;	// w肵D_CubismMotionQueueEntry̎擾
	void						SetEventCallback( D_CubismMotionEventFunction callback, void* customData = NULL ) ;		// Cxg󂯎Callback̓o^
	float						GetMotionPlayTime(){ return _motionPlayTime; }

protected:
	virtual bool				DoUpdateMotion( D_CubismModel* model, float userTimeSeconds ) ;							// [V̍XV

	float										_userTimeSeconds ;	// f^Ԃ̐ώZl[b]
	float										_motionPlayTime ;	// [VĐ

private:
	D_csmVector< D_CubismMotionQueueEntry * >   _motions ;			// [V
	D_CubismMotionEventFunction					_eventCallback ;	// R[obN֐|C^
	void*										_eventCustomData ;	// R[obNɖ߂f[^
} ;

// [V̒ۊNX
class D_ACubismMotion
{
public:
	static void					Delete( D_ACubismMotion* motion ) ;							// CX^X̔j
	D_ACubismMotion() ;																		// RXgN^
	void						UpdateParameters( D_CubismModel* model, D_CubismMotionQueueEntry* motionQueueEntry, float userTimeSeconds ) ;	// f̃p[^XV
	void						SetFadeInTime( float fadeInSeconds ) ;						// tF[hC
	void						SetFadeOutTime( float fadeOutSeconds ) ;					// tF[hAEg
	float						GetFadeOutTime() const ;									// tF[hAEgɂ鎞Ԃ̎擾
	float						GetFadeInTime() const ;										// tF[hCɂ鎞Ԃ̎擾
	void						SetWeight( float weight ) ;									// [VKp̏d݂̐ݒ
	float						GetWeight() const ;											// [VKp̏d݂̎擾
	virtual float				GetDuration() ;												// [V̒̎擾
	virtual float				GetLoopDuration() ;											// [Ṽ[v1񕪂̒̎擾
	void						SetOffsetTime( float offsetSeconds ) ;						// [VĐ̊Jn̐ݒ
	virtual const D_csmVector< const D_csmString * >& GetFiredEvent( float beforeCheckTimeSeconds, float motionTimeSeconds ) ;	// f̃p[^XV

private:
	// Prevention of copy Constructor
	D_ACubismMotion( const D_ACubismMotion& ) ;
	D_ACubismMotion& operator=( const D_ACubismMotion& ) ;

protected:
	virtual ~D_ACubismMotion() ;															// fXgN^
	virtual void				DoUpdateParameters( D_CubismModel* model, float userTimeSeconds, float weight, D_CubismMotionQueueEntry* motionQueueEntry ) = 0 ;// f̃p[^̍XV̎s

	float						_fadeInSeconds ;			// tF[hCɂ鎞[b]
	float						_fadeOutSeconds ;			// tF[hAEgɂ鎞[b]
	float						_weight ;					// [V̏d
	float						_offsetSeconds ;			// [VĐ̊Jn[b]
	D_csmVector< const D_csmString * >	_firedEventValues ;
} ;

// \̃[V
class D_CubismExpressionMotion : public D_ACubismMotion
{
private:
	// \p[^ľvZ
	enum ExpressionBlendType
	{
		ExpressionBlendType_Add					= 0,		// Z
		ExpressionBlendType_Multiply			= 1,		// Z
		ExpressionBlendType_Overwrite			= 2			// ㏑
	} ;

public:
	// \̃p[^
	struct D_ExpressionParameter
	{
		D_CubismIdHandle		ParameterId ;	// p[^ID
		ExpressionBlendType		BlendType ;		// p[^̉Z
		float					Value ;			// l
	} ;
	static D_CubismExpressionMotion*	Create( const BYTE* buf, size_t size ) ;				// CX^X̍쐬
	virtual void						DoUpdateParameters( D_CubismModel* model, float userTimeSeconds, float weight, D_CubismMotionQueueEntry* motionQueueEntry ) ;	// f̃p[^̍XV̎s

private:
	D_CubismExpressionMotion() ;
	virtual ~D_CubismExpressionMotion() ;

	D_csmVector<D_ExpressionParameter> _parameters ;		// \̃p[^񃊃Xg
} ;

// [VNX
class D_CubismMotion : public D_ACubismMotion
{
public:
	static D_CubismMotion*		Create( const BYTE* buffer, size_t size ) ;									// CX^X̐
	virtual void				DoUpdateParameters( D_CubismModel* model, float userTimeSeconds, float fadeWeight, D_CubismMotionQueueEntry* motionQueueEntry ) ;	// f̃p[^̍XV̎s
	void						IsLoop( bool loop ) ;														// [v̐ݒ
	bool						IsLoop() const ;															// [v̎擾
	void						IsLoopFadeIn( bool loopFadeIn ) ;											// [ṽtF[hC̐ݒ
	bool						IsLoopFadeIn() const ;														// [ṽtF[hC̎擾
	virtual float				GetDuration() ;																// [V̒̎擾
	virtual float				GetLoopDuration() ;															// [Ṽ[v̒̎擾
	void						SetParameterFadeInTime( D_CubismIdHandle parameterId, float value ) ;		// p[^ɑ΂tF[hC̎Ԃ̐ݒ
	void						SetParameterFadeOutTime( D_CubismIdHandle parameterId, float value ) ;		// p[^ɑ΂tF[hAEg̎Ԃ̐ݒ
	float						GetParameterFadeInTime( D_CubismIdHandle parameterId ) const ;				// p[^ɑ΂tF[hC̎Ԃ̎擾
	float						GetParameterFadeOutTime( D_CubismIdHandle parameterId ) const ;				// p[^ɑ΂tF[hAEg̎Ԃ̎擾
	void						SetEffectIds( const D_csmVector<D_CubismIdHandle>& eyeBlinkParameterIds, const D_csmVector<D_CubismIdHandle>& lipSyncParameterIds ) ;	// GtFNgĂp[^IDXg̐ݒ
	virtual const D_csmVector< const D_csmString * >& GetFiredEvent( float beforeCheckTimeSeconds, float motionTimeSeconds ) ;	// f̃p[^XV

private:
	D_CubismMotion() ;																		// RXgN^
	virtual ~D_CubismMotion() ;																// fXgN^
	D_CubismMotion( const D_CubismMotion& ) ;												// Prevention of copy Constructor
	D_CubismMotion& operator=( const D_CubismMotion& ) ;
	void Parse( const BYTE* motionJson, const size_t size ) ;								// motion3.jsoñp[X

	float						_sourceFrameRate ;			// [ht@CFPSBLq΃ftHgl15fpsƂȂ
	float						_loopDurationSeconds ;		// mtnt@CŒ`Ã[V̒
	bool						_isLoop ;					// [v邩?
	bool						_isLoopFadeIn ;				// [vɃtF[hCLǂ̃tOBlł͗LB
	float						_lastWeight ;				// Ōɐݒ肳ꂽd
	D_CubismMotionData*			_motionData ;				// ۂ̃[Vf[^{
	D_csmVector< D_CubismIdHandle >	_eyeBlinkParameterIds ;	// ܂΂Kpp[^IDnh̃XgB  fifZbeBOjƃp[^ΉtB
	D_csmVector< D_CubismIdHandle >	_lipSyncParameterIds ;	// bvVNKpp[^IDnh̃XgB  fifZbeBOjƃp[^ΉtB
	D_CubismIdHandle			_modelCurveIdEyeBlink ;		// f܂΂pp[^ID̃nhB  fƃ[VΉtB
	D_CubismIdHandle			_modelCurveIdLipSync ;		// fbvVNpp[^ID̃nhB  fƃ[VΉtB
} ;

// fWݒp4x4s
class D_CubismModelMatrix : public D_CubismMatrix44
{
public:
	D_CubismModelMatrix() ;																	// RXgN^
	D_CubismModelMatrix( float w, float h ) ;												// RXgN^
	virtual ~D_CubismModelMatrix() ;														// fXgN^
	void						SetWidth( float w ) ;										// ݒ
	void						SetHeight( float h ) ;										// cݒ
	void						SetPosition( float x, float y ) ;							// ʒuݒ
	void						SetCenterPosition( float x, float y ) ;						// Sʒuݒ
	void						Top( float y ) ;											// ӂ̈ʒuݒ
	void						Bottom( float y ) ;											// ӂ̈ʒuݒ
	void						Left( float x ) ;											// ӂ̈ʒuݒ
	void						Right( float x ) ;											// Eӂ̈ʒuݒ
	void						CenterX( float x ) ;										// X̒Sʒuݒ
	void						SetX( float x ) ;											// Ẍʒuݒ
	void						CenterY( float y ) ;										// Y̒Sʒuݒ
	void						SetY( float y ) ;											// Ÿʒuݒ
	void						SetupFromLayout( D_csmMap<D_csmString, float>& layout ) ;	// CAEg񂩂ʒuݒ

private:
	float						_width ;					// 
	float						_height ;					// c
} ;

// [V̊Ǘ
class D_CubismMotionManager : public D_CubismMotionQueueManager
{
public:
	D_CubismMotionManager() ;																// RXgN^
	virtual ~D_CubismMotionManager() ;														// fXgN^
	int							GetCurrentPriority() const ;								// Đ̃[V̗Dx̎擾
	int							GetReservePriority() const ;								// \񒆂̃[V̗Dx̎擾
	void						SetReservePriority( int val ) ;								// \񒆂̃[V̗Dx̐ݒ
	D_CubismMotionQueueEntryHandle StartMotionPriority( D_ACubismMotion* motion, bool autoDelete, int priority ) ;// Dxݒ肵ă[V̊Jn
	bool						UpdateMotion( D_CubismModel* model, float deltaTimeSeconds ) ;	// [V̍XV
	bool						ReserveMotion( int priority ) ;								// [V̗\

private:
	int							_currentPriority ;                 // ݍĐ̃[V̗Dx
	int							_reservePriority ;                 // Đ\̃[V̗DxBĐ0ɂȂB[Vt@CʃXbhœǂݍނƂ̏
} ;

// fݒ舵֐錾zNXB
class D_ICubismModelSetting
{
public:
	virtual ~D_ICubismModelSetting() {}																// fXgN^
	virtual const char*					GetModelFileName() = 0 ;											// Moct@C̖O擾
	virtual const char*					GetModelFileNameA() = 0 ;											// Moct@C̖O擾
	virtual const BYTE/*wchar_t*/ *		GetModelFileNameW() = 0 ;											// Moct@C̖O擾
	virtual int							GetTextureCount() = 0 ;												// fgpeNX`̐擾
	virtual const char*					GetTextureDirectory() = 0 ;											// eNX`zuꂽfBNg̖O擾
	virtual const char*					GetTextureDirectoryA() = 0 ;										// eNX`zuꂽfBNg̖O擾
	virtual const BYTE/*wchar_t*/ *		GetTextureDirectoryW() = 0 ;										// eNX`zuꂽfBNg̖O擾
	virtual const char*					GetTextureFileName( int index ) = 0 ;								// fgpeNX`̖O擾
	virtual const char*					GetTextureFileNameA( int index ) = 0 ;								// fgpeNX`̖O擾
	virtual const BYTE/*wchar_t*/ *		GetTextureFileNameW( int index ) = 0 ;								// fgpeNX`̖O擾
	virtual int							GetHitAreasCount() = 0 ;											// fɐݒ肳ꂽ蔻̐擾
	virtual D_CubismIdHandle			GetHitAreaId( int index ) = 0 ;										// 蔻ɐݒ肳ꂽID擾
	virtual const char*					GetHitAreaName( int index ) = 0 ;									// 蔻ɐݒ肳ꂽO擾
	virtual const char*					GetHitAreaNameA( int index ) = 0 ;									// 蔻ɐݒ肳ꂽO擾
	virtual const BYTE/*wchar_t*/ *		GetHitAreaNameW( int index ) = 0 ;									// 蔻ɐݒ肳ꂽO擾
	virtual const char*					GetPhysicsFileName() = 0 ;											// Zݒt@C̖O擾
	virtual const char*					GetPhysicsFileNameA() = 0 ;											// Zݒt@C̖O擾
	virtual const BYTE/*wchar_t*/ *		GetPhysicsFileNameW() = 0 ;											// Zݒt@C̖O擾
	virtual const char*					GetPoseFileName() = 0 ;												// p[c؂ւݒt@C̖O擾
	virtual const char*					GetPoseFileNameA() = 0 ;											// p[c؂ւݒt@C̖O擾
	virtual const BYTE/*wchar_t*/ *		GetPoseFileNameW() = 0 ;											// p[c؂ւݒt@C̖O擾
	virtual int							GetExpressionCount() = 0 ;											// \ݒt@C̐擾
	virtual const char*					GetExpressionName( int index ) = 0 ;								// \ݒt@Cʂ閼Oiʖj擾
	virtual const char*					GetExpressionNameA( int index ) = 0 ;								// \ݒt@Cʂ閼Oiʖj擾
	virtual const BYTE/*wchar_t*/ *		GetExpressionNameW( int index ) = 0 ;								// \ݒt@Cʂ閼Oiʖj擾
	virtual const char*					GetExpressionFileName( int index ) = 0 ;							// \ݒt@C̖O擾
	virtual const char*					GetExpressionFileNameA( int index ) = 0 ;							// \ݒt@C̖O擾
	virtual const BYTE/*wchar_t*/ *		GetExpressionFileNameW( int index ) = 0 ;							// \ݒt@C̖O擾
	virtual int							GetMotionGroupCount() = 0 ;											// [VO[v̐擾
	virtual const char*					GetMotionGroupName( int index ) = 0 ;								// [VO[v̖O擾
	virtual const char*					GetMotionGroupNameA( int index ) = 0 ;								// [VO[v̖O擾
	virtual const BYTE/*wchar_t*/ *		GetMotionGroupNameW( int index ) = 0 ;								// [VO[v̖O擾
	virtual int							GetMotionCount( const char* groupName ) = 0 ;						// [VO[vɊ܂܂郂[V̐擾
	virtual const char*					GetMotionFileName( const char* groupName, int index ) = 0 ;			// O[vƃCfbNXl烂[Vt@C̖O擾
	virtual const char*					GetMotionFileNameA( const char* groupName, int index ) = 0 ;		// O[vƃCfbNXl烂[Vt@C̖O擾
	virtual const BYTE/*wchar_t*/ *		GetMotionFileNameW( const char* groupName, int index ) = 0 ;		// O[vƃCfbNXl烂[Vt@C̖O擾
	virtual const char*					GetMotionSoundFileName( const char* groupName, int index ) = 0 ;	// [VɑΉTEht@C̖O擾
	virtual const char*					GetMotionSoundFileNameA( const char* groupName, int index ) = 0 ;	// [VɑΉTEht@C̖O擾
	virtual const BYTE/*wchar_t*/ *		GetMotionSoundFileNameW( const char* groupName, int index ) = 0 ;	// [VɑΉTEht@C̖O擾
	virtual float						GetMotionFadeInTimeValue( const char* groupName, int index ) = 0 ;	// [VJñtF[hCԂ擾
	virtual float						GetMotionFadeOutTimeValue( const char* groupName, int index ) = 0 ;	// [VĨtF[hAEgԂ擾
	virtual const char*					GetUserDataFile() = 0 ;												// [Uf[^̃t@C擾
	virtual const char*					GetUserDataFileA() = 0 ;											// [Uf[^̃t@C擾
	virtual const BYTE/*wchar_t*/ *		GetUserDataFileW() = 0 ;											// [Uf[^̃t@C擾
	virtual bool						GetLayoutMap( D_csmMap<D_csmString, float>& outLayoutMap ) = 0 ;	// CAEg擾
	virtual int							GetEyeBlinkParameterCount() = 0 ;									// ڃp`Ɋ֘Atꂽp[^̐擾
	virtual D_CubismIdHandle			GetEyeBlinkParameterId( int index ) = 0 ;							// ڃp`Ɋ֘Atꂽp[^ID擾
	virtual int							GetLipSyncParameterCount() = 0 ;									// bvVNɊ֘Atꂽp[^̐擾
	virtual D_CubismIdHandle			GetLipSyncParameterId( int index ) = 0 ;							// bvVNɊ֘Atꂽp[^ID擾
} ;

// Model3Jsonp[T[.
class D_CubismModelSettingJson : public D_ICubismModelSetting
{
public:
	D_CubismModelSettingJson( const BYTE* buffer, size_t size ) ;								// tRXgN^
	virtual ~D_CubismModelSettingJson() ;													// fXgN^
	D_CubismJson*				GetJsonPointer() const ;									// CubismJsonIuWFNg̃|C^擾
	const char*					GetModelFileName() ;
	const char*					GetModelFileNameA() ;
	const BYTE/*wchar_t*/ *		GetModelFileNameW() ;
	int							GetTextureCount() ;
	const char*					GetTextureDirectory() ;
	const char*					GetTextureDirectoryA() ;
	const BYTE/*wchar_t*/ *		GetTextureDirectoryW() ;
	const char*					GetTextureFileName( int index ) ;
	const char*					GetTextureFileNameA( int index ) ;
	const BYTE/*wchar_t*/ *		GetTextureFileNameW( int index ) ;
	int							GetHitAreasCount() ;
	D_CubismIdHandle			GetHitAreaId( int index ) ;
	const char*					GetHitAreaName( int index ) ;
	const char*					GetHitAreaNameA( int index ) ;
	const BYTE/*wchar_t*/ *		GetHitAreaNameW( int index ) ;
	const char*					GetPhysicsFileName() ;
	const char*					GetPhysicsFileNameA() ;
	const BYTE/*wchar_t*/ *		GetPhysicsFileNameW() ;
	const char*					GetPoseFileName() ;
	const char*					GetPoseFileNameA() ;
	const BYTE/*wchar_t*/ *		GetPoseFileNameW() ;
	int							GetExpressionCount() ;
	const char*					GetExpressionName( int index ) ;
	const char*					GetExpressionNameA( int index ) ;
	const BYTE/*wchar_t*/ *		GetExpressionNameW( int index ) ;
	const char*					GetExpressionFileName( int index ) ;
	const char*					GetExpressionFileNameA( int index ) ;
	const BYTE/*wchar_t*/ *		GetExpressionFileNameW( int index ) ;
	int							GetMotionGroupCount() ;
	const char*					GetMotionGroupName( int index ) ;
	const char*					GetMotionGroupNameA( int index ) ;
	const BYTE/*wchar_t*/ *		GetMotionGroupNameW( int index ) ;
	int							GetMotionCount( const char* groupName ) ;
	const char*					GetMotionFileName( const char* groupName, int index ) ;
	const char*					GetMotionFileNameA( const char* groupName, int index ) ;
	const BYTE/*wchar_t*/ *		GetMotionFileNameW( const char* groupName, int index ) ;
	const char*					GetMotionSoundFileName( const char* groupName, int index ) ;
	const char*					GetMotionSoundFileNameA( const char* groupName, int index ) ;
	const BYTE/*wchar_t*/ *		GetMotionSoundFileNameW( const char* groupName, int index ) ;
	float						GetMotionFadeInTimeValue( const char* groupName, int index ) ;
	float						GetMotionFadeOutTimeValue( const char* groupName, int index ) ;
	const char*					GetUserDataFile() ;
	const char*					GetUserDataFileA() ;
	const BYTE/*wchar_t*/ *		GetUserDataFileW() ;
	bool						GetLayoutMap( D_csmMap<D_csmString, float>& outLayoutMap ) ;
	int							GetEyeBlinkParameterCount() ;
	D_CubismIdHandle			GetEyeBlinkParameterId( int index ) ;
	int							GetLipSyncParameterCount() ;
	D_CubismIdHandle			GetLipSyncParameterId( int index ) ;

private:
	enum FrequentNode
	{
		FrequentNode_Groups,		// GetRoot()[Groups] 
		FrequentNode_Moc,			// GetRoot()[FileReferences][Moc] 
		FrequentNode_Motions,		// GetRoot()[FileReferences][Motions] 
		FrequentNode_Expressions,	// GetRoot()[FileReferences][Expressions] 
		FrequentNode_Textures,		// GetRoot()[FileReferences][Textures] 
		FrequentNode_Physics,		// GetRoot()[FileReferences][Physics] 
		FrequentNode_Pose,			// GetRoot()[FileReferences][Pose] 
		FrequentNode_HitAreas,		// GetRoot()[HitAreas] 
	} ;

	bool						IsExistModelFile() const ;											// ft@C̃L[݂邩ǂmF
	bool						IsExistTextureFiles() const ;										// eNX`t@C̃L[݂邩ǂmF
	bool						IsExistHitAreas() const ;											// 蔻̃L[݂邩ǂmF
	bool						IsExistPhysicsFile() const ;										// Zt@C̃L[݂邩ǂmF
	bool						IsExistPoseFile() const ;											// |[Yݒt@C̃L[݂邩ǂmF
	bool						IsExistExpressionFile() const ;										// \ݒt@C̃L[݂邩ǂmF
	bool						IsExistMotionGroups() const ;										// [VO[ṽL[݂邩ǂmF
	bool						IsExistMotionGroupName( const char* groupName ) const ;				// Ŏw肵[VO[ṽL[݂邩ǂmF
	bool						IsExistMotionSoundFile( const char* groupName, int index ) const ;	// Ŏw肵[VɑΉTEht@C̃L[݂邩ǂmF
	bool						IsExistMotionFadeIn( const char* groupName, int index ) const ;		// Ŏw肵[VɑΉtF[hCԂ̃L[݂邩ǂmF
	bool						IsExistMotionFadeOut( const char* groupName, int index ) const ;	// Ŏw肵[VɑΉtF[hAEgԂ̃L[݂邩ǂmF
	bool						IsExistUserDataFile() const ;										// UserDatãt@C݂邩mF
	bool						IsExistEyeBlinkParameters() const ;									// ڃp`ɑΉtꂽp[^݂邩ǂmF
	bool						IsExistLipSyncParameters() const ;									// bvVNɑΉtꂽp[^݂邩ǂmF

	D_CubismJson*				_json ;      // ff[^json 
	D_csmVector<D_JsonValue*>	_jsonValue ; // json̕pom[h 
} ;

// ܂΂
class D_CubismEyeBlink
{
public:
	// ܂΂̏
	enum EyeState
	{
		EyeState_First							= 0,		// 
		EyeState_Interval						= 1,		// ܂΂ĂȂ
		EyeState_Closing						= 2,		// ܂ԂĂȑ
		EyeState_Closed							= 3,		// ܂ԂĂ
		EyeState_Opening						= 4			// ܂ԂJĂȑ
	} ;

	static D_CubismEyeBlink*	Create( D_ICubismModelSetting* modelSetting = NULL ) ;				// CX^X̍쐬
	static void					Delete( D_CubismEyeBlink* eyeBlink ) ;								// CX^X̔j
	void						SetBlinkingInterval( float blinkigInterval ) ;						// ܂΂̊Ԋu̐ݒ
	void						SetBlinkingSettings( float closing, float closed, float opening ) ;	// ܂΂̃[V̏ڍאݒ
	void						SetParameterIds( const D_csmVector<D_CubismIdHandle>& parameterIds ) ;// ܂΂p[^ID̃Xg̐ݒ
	const D_csmVector<D_CubismIdHandle>&     GetParameterIds() const ;								// ܂΂p[^ID̃Xg̎擾
	void						UpdateParameters( D_CubismModel* model, float deltaTimeSeconds ) ;	// f̃p[^̍XV

public:
	D_CubismEyeBlink( D_ICubismModelSetting* modelSetting ) ;								// RXgN^
	virtual ~D_CubismEyeBlink() ;															// fXgN^
	float						DeterminNextBlinkingTiming() const ;						// ̂܂΂̃^C~Ǒ

	int							_blinkingState ;			// ݂̏
	D_csmVector<D_CubismIdHandle>   _parameterIds ;			// Ώۂ̃p[^ID̃Xg
	float						_nextBlinkingTime ;			// ̂܂΂̎[b]
	float						_stateStartTimeSeconds ;	// ݂̏ԂJn[b]
	float						_blinkingIntervalSeconds ;	// ܂΂̊Ԋu[b]
	float						_closingSeconds ;			// ܂Ԃ铮̏v[b]
	float						_closedSeconds ;			// ܂ԂĂ铮̏v[b]
	float						_openingSeconds ;			// ܂ԂJ̏v[b]
	float						_userTimeSeconds ;			// f^Ԃ̐ώZl[b]

} ;

// ċz
class D_CubismBreath
{
public:
	// ċz̃p[^
	struct BreathParameterData
	{
		BreathParameterData() : ParameterId( NULL ), Offset( 0.0f ), Peak( 0.0f ), Cycle( 0.0f ), Weight( 0.0f ) { }	// RXgN^
		BreathParameterData( D_CubismIdHandle parameterId, float offset, float peak, float cycle, float weight )		// RXgN^
			: ParameterId( parameterId )
			, Offset( offset )
			, Peak( peak )
			, Cycle( cycle )
			, Weight( weight )
		{ }
		D_CubismIdHandle		ParameterId ;				// ċzЂÂp[^ID
		float					Offset ;					// ċz𐳌gƂƂ́Ag̃ItZbg
		float					Peak ;						// ċz𐳌gƂƂ́Ag̍
		float					Cycle ;						// ċz𐳌gƂƂ́Ag̎
		float					Weight ;					// p[^ւ̏d
	} ;
	static D_CubismBreath*		Create() ;																	// CX^X̍쐬
	static void					Delete( D_CubismBreath* instance ) ;										// CX^X̔j
	void						SetParameters( D_csmVector<BreathParameterData>& breathParameters ) ;		// ċz̃p[^̂ЂÂ
	D_csmVector<BreathParameterData>& GetParameters() ;														// ċzɂЂÂĂp[^̎擾
	void						UpdateParameters( D_CubismModel* model, float deltaTimeSeconds ) ;			// f̃p[^̍XV

private:
	D_CubismBreath() ;																		// RXgN^
	virtual ~D_CubismBreath() ;																// fXgN^

	D_csmVector<BreathParameterData> _breathParameters ;	// ċzɂЂÂĂp[^̃Xg
	float						_currentTime ;				// ώZ[b]
} ;

// p[c̕sx̐ݒ
class D_CubismPose
{
public:
	// p[cɂ܂f[^Ǘ
	struct PartData
	{
		PartData() ;																		// RXgN^
		PartData( const PartData& v ) ;														// Rs[RXgN^
		virtual ~PartData() ;																// fXgN^
		PartData&				operator=( const PartData& v ) ;							// ̃I[o[[h
		void					Initialize( D_CubismModel* model ) ;						// 

		D_CubismIdHandle		PartId ;					// p[cID
		int						ParameterIndex ;			// p[^̃CfbNX
		int						PartIndex ;					// p[c̃CfbNX
		D_csmVector<PartData>	Link ;						// Ap[^
	} ;
	static D_CubismPose*		Create( const BYTE* pose3json, size_t size ) ;// CX^X̍쐬
	static void					Delete( D_CubismPose* pose ) ;// CX^X̔j
	void						UpdateParameters( D_CubismModel* model, float deltaTimeSeconds ) ;// f̃p[^̍XV

private:
	D_CubismPose() ;																		// RXgN^
	virtual ~D_CubismPose() ;																// fXgN^
	void						Reset( D_CubismModel* model ) ;								// \
	void						CopyPartOpacities( D_CubismModel* model ) ;					// p[c̕sxRs[
	void						DoFade( D_CubismModel* model, float deltaTimeSeconds, int beginIndex, int partGroupCount ) ;// p[c̃tF[hs

	D_csmVector<PartData>		_partGroups ;				// p[cO[v
	D_csmVector<int>			_partGroupCounts ;			// ꂼ̃p[cO[v̌
	float						_fadeTimeSeconds ;			// tF[h[b]
	D_CubismModel*				_lastModel ;				// O񑀍삵f
} ;

// ̌̐䏈
class D_CubismTargetPoint
{
public:
	D_CubismTargetPoint() ;																	// RXgN^
	virtual ~D_CubismTargetPoint() ;														// fXgN^
	void						Update( float deltaTimeSeconds ) ;							// XV
	float						GetX() const ;												// X̊̌̒l擾
	float						GetY() const ;												// Y̊̌̒l擾
	void						Set( float x, float y ) ;									// ̖̌ڕWlݒ

private:
	float						_faceTargetX ;				// ̌XڕWl(̒lɋ߂ÂĂ)
	float						_faceTargetY ;				// ̌YڕWl(̒lɋ߂ÂĂ)
	float						_faceX ;					// ̌X(-1.0 - 1.0)
	float						_faceY ;					// ̌Y(-1.0 - 1.0)
	float						_faceVX ;					// ̌̕ωxX
	float						_faceVY ;					// ̌̕ωxY
	float						_lastTimeSeconds ;			// Ō̎s[b]
	float						_userTimeSeconds ;			// f^Ԃ̐ώZl[b]
} ;

// Z̓Kp̎
enum D_CubismPhysicsTargetType
{
    D_CubismPhysicsTargetType_Parameter			= 0,		// p[^ɑ΂ēKp
} ;

// Z̓͂̎
enum D_CubismPhysicsSource
{
    D_CubismPhysicsSource_X						= 0,		// Ẍʒu
    D_CubismPhysicsSource_Y						= 1,		// Ÿʒu
    D_CubismPhysicsSource_Angle					= 2,		// px
} ;

// ZŎgpO̗
struct D_PhysicsJsonEffectiveForces
{
    D_CubismVector2				Gravity ;					// d
    D_CubismVector2				Wind ;						// 
} ;

// Z̃p[^
struct D_CubismPhysicsParameter
{
    D_CubismIdHandle			Id ;						// p[^ID
    D_CubismPhysicsTargetType	TargetType ;				// Kp̎
} ;

// Z̐K
struct D_CubismPhysicsNormalization
{
    float						Minimum ;					// ől
    float						Maximum ;					// ŏl
    float						Default ;					// ftHgl
} ;

// Z̉ZɎgp镨_̏
struct D_CubismPhysicsParticle
{
    D_CubismVector2				InitialPosition ;			// ʒu
    float						Mobility ;					// ₷
    float						Delay ;						// x
    float						Acceleration ;				// x
    float						Radius ;					// 
    D_CubismVector2				Position ;					// ݂̈ʒu
    D_CubismVector2				LastPosition ;				// Ō̈ʒu
    D_CubismVector2				LastGravity ;				// Ō̏d
    D_CubismVector2				Force ;						// ݂Ă
    D_CubismVector2				Velocity ;					// ݂̑x
} ;

// Z̕_̊Ǘ
struct D_CubismPhysicsSubRig
{
    int							InputCount ;				// ͂̌
    int							OutputCount ;				// o͂̌
    int							ParticleCount ;				// _̌
    int							BaseInputIndex ;			// ͂̍ŏ̃CfbNX
    int							BaseOutputIndex ;			// o͂̍ŏ̃CfbNX
    int							BaseParticleIndex ;			// _̍ŏ̃CfbNX
    D_CubismPhysicsNormalization NormalizationPosition ;	// Kꂽʒu
    D_CubismPhysicsNormalization NormalizationAngle ;		// Kꂽpx
} ;

// Kꂽp[^̎擾֐̐錾
typedef void ( *D_NormalizedPhysicsParameterValueGetter )(
    D_CubismVector2*			targetTranslation,
    float*						targetAngle,
    float						value,
    float						parameterMinimumValue,
    float						parameterMaximumValue,
    float						parameterDefaultValue,
    D_CubismPhysicsNormalization* normalizationPosition,
    D_CubismPhysicsNormalization* normalizationAngle,
    int							isInverted,
    float						weight
) ;

// Z̒l̎擾֐̐錾
typedef float ( *D_PhysicsValueGetter )(
    D_CubismVector2				translation,
    D_CubismPhysicsParticle*	particles,
    int							particleIndex,
    int							isInverted,
    D_CubismVector2				parentGravity
) ;

// Z̃XP[̎擾֐̐錾
typedef float ( *D_PhysicsScaleGetter )( D_CubismVector2 translationScale, float angleScale ) ;

// Z̓͏
struct D_CubismPhysicsInput
{
    D_CubismPhysicsParameter	Source ;					// ͌̃p[^
    int							SourceParameterIndex ;		// ͌̃p[^̃CfbNX
    float						Weight ;					// d
    short						Type ;						// ͂̎
    short						Reflect ;					// l]Ă邩ǂ
    D_NormalizedPhysicsParameterValueGetter GetNormalizedParameterValue ;	// Kꂽp[^l̎擾֐
} ;

// Z̏o͏
struct D_CubismPhysicsOutput
{
    D_CubismPhysicsParameter	Destination ;				// o͐̃p[^
    int							DestinationParameterIndex ;	// o͐̃p[^̃CfbNX
    int							VertexIndex ;				// Uq̃CfbNX
    D_CubismVector2				TranslationScale ;			// ړl̃XP[
    float						AngleScale ;				// px̃XP[
    float						Weight ;					// d
    D_CubismPhysicsSource		Type ;						// o͂̎
    short						Reflect ;					// l]Ă邩ǂ
    float						ValueBelowMinimum ;			// ŏl̒l
    float						ValueExceededMaximum ;		// ől̒l
    D_PhysicsValueGetter		GetValue ;					// Z̒l̎擾֐
    D_PhysicsScaleGetter		GetScale ;					// Z̃XP[l̎擾֐
} ;

// Z̃f[^
struct D_CubismPhysicsRig
{
    int							SubRigCount ;				// Z̕_̌
    D_csmVector<D_CubismPhysicsSubRig> Settings ;			// Z̕_̊Ǘ̃Xg
    D_csmVector<D_CubismPhysicsInput> Inputs ;				// Z̓͂̃Xg
    D_csmVector<D_CubismPhysicsOutput> Outputs ;			// Z̏o͂̃Xg
    D_csmVector<D_CubismPhysicsParticle> Particles ;		// Z̕_̃Xg
    D_CubismVector2				Gravity ;					// d
    D_CubismVector2				Wind ;						// 
} ;

// physics3.jsoñRei
class D_CubismPhysicsJson
{
public:
	D_CubismPhysicsJson( const BYTE* buffer, size_t size ) ;													// RXgN^
	virtual ~D_CubismPhysicsJson() ;																			// fXgN^
	D_CubismVector2				GetGravity() const ;														// d͂̎擾
	D_CubismVector2				GetWind() const ;															// ̎擾
	int							GetSubRigCount() const ;													// _̊Ǘ̌̎擾
	int							GetTotalInputCount() const ;												// ͂̑v̎擾
	int							GetTotalOutputCount() const ;												// o͂̑v̎擾
	int							GetVertexCount() const ;													// _̌̎擾
	float						GetNormalizationPositionMinimumValue( int physicsSettingIndex ) const ;		// Kꂽʒu̍ŏl̎擾
	float						GetNormalizationPositionMaximumValue( int physicsSettingIndex ) const ;		// Kꂽʒu̍ől̎擾
	float						GetNormalizationPositionDefaultValue( int physicsSettingIndex ) const ;		// KꂽʒũftHgl̎擾
	float						GetNormalizationAngleMinimumValue( int physicsSettingIndex ) const ;		// Kꂽpx̍ŏl̎擾
	float						GetNormalizationAngleMaximumValue( int physicsSettingIndex ) const ;		// Kꂽpx̍ől̎擾
	float						GetNormalizationAngleDefaultValue( int physicsSettingIndex ) const ;		// Kꂽpx̃ftHgl̎擾
	int							GetInputCount( int physicsSettingIndex ) const ;							// ͂̌̎擾
	float						GetInputWeight( int physicsSettingIndex, int inputIndex ) const ;			// ͂̏d݂̎擾
	bool						GetInputReflect( int physicsSettingIndex, int inputIndex ) const ;			// ͂̔]̎擾
	const char*					GetInputType( int physicsSettingIndex, int inputIndex ) const ;				// ͂̎ނ̎擾
	D_CubismIdHandle			GetInputSourceId( int physicsSettingIndex, int inputIndex ) const ;			// ͌ID̎擾
	int							GetOutputCount( int physicsSettingIndex ) const ;							// o͂̌̎擾
	int							GetOutputVertexIndex( int physicsSettingIndex, int outputIndex ) const ;	// o͂̕_̃CfbNX̎擾
	float						GetOutputAngleScale( int physicsSettingIndex, int outputIndex ) const ;		// o͂̊px̃XP[̎擾
	float						GetOutputWeight( int physicsSettingIndex, int outputIndex ) const ;			// o͂̏d݂̎擾
	D_CubismIdHandle			GetOutputsDestinationId( int physicsSettingIndex, int outputIndex ) const ;	// o͐ID̎擾
	const char*					GetOutputType( int physicsSettingIndex, int outputIndex ) const ;			// o͂̎ނ̎擾
	bool						GetOutputReflect( int physicsSettingIndex, int outputIndex ) const ;		// o͂̔]̎擾
	int							GetParticleCount( int physicsSettingIndex ) const ;							// _̌̎擾
	float						GetParticleMobility( int physicsSettingIndex, int vertexIndex ) const ;		// _̓₷̎擾
	float						GetParticleDelay( int physicsSettingIndex, int vertexIndex ) const ;		// _̒x̎擾
	float						GetParticleAcceleration( int physicsSettingIndex, int vertexIndex ) const ;	// _̉x̎擾
	float						GetParticleRadius( int physicsSettingIndex, int vertexIndex ) const ;		// _̋̎擾
	D_CubismVector2				GetParticlePosition( int physicsSettingIndex, int vertexIndex ) const ;		// _̈ʒu̎擾

private:
	D_CubismJson* _json ;          // physics3.jsonf[^
} ;

// ZNX
class D_CubismPhysics
{
public:
	// IvV
	struct Options
	{
		D_CubismVector2			Gravity ;					// d͕
		D_CubismVector2			Wind ;						// ̕
	} ;
	static D_CubismPhysics*		Create( const BYTE* buffer, size_t size ) ;					// CX^X̍쐬
	static void					Delete( D_CubismPhysics* physics ) ;						// CX^X̔j
	void						Evaluate( D_CubismModel* model, float deltaTimeSeconds ) ;	// Z̕]
	void						SetOptions( const Options& options ) ;						// IvV̐ݒ
	const Options&				GetOptions() const ;										// IvV̎擾

private:
	D_CubismPhysics() ;																		// RXgN^
	virtual ~D_CubismPhysics() ;															// fXgN^
	D_CubismPhysics( const D_CubismPhysics& ) ;
	D_CubismPhysics&			operator=( const D_CubismPhysics& ) ;
	void						Parse( const BYTE* physicsJson, size_t size ) ;				// physics3.jsoñp[X
	void						Initialize() ;												// 

	D_CubismPhysicsRig*			_physicsRig ;				// Z̃f[^
	Options						_options ;					// IvV
} ;

class D_CubismModelUserDataJson
{
public:
	D_CubismModelUserDataJson( const BYTE* buffer, size_t size ) ;							// RXgN^
	virtual ~D_CubismModelUserDataJson() ;													// fXgN^
	int							GetUserDataCount() const ;									// [Uf[^̎擾
	int							GetTotalUserDataSize() const ;								// [Uf[^񐔂̎擾
	D_csmString					GetUserDataTargetType( int i ) const ;						// [Uf[^̃^Cv̎擾
	D_CubismIdHandle			GetUserDataId( int i ) const ;								// [Uf[^̃^[QbgID̎擾
	const char*					GetUserDataValue( int i ) const ;							// [Uf[^̎̕擾

private:
	D_CubismJson*				_json ;
} ;

// [Uf[^̊ǗNX
class D_CubismModelUserData
{
public:
	// [Uf[^\
	struct CubismModelUserDataNode
	{
		D_CubismIdHandle		TargetType ;				// [Uf[^^[Qbg^Cv
		D_CubismIdHandle		TargetId ;					// [Uf[^^[QbgID
		D_csmString				Value ;						// [Uf[^
	} ;
	static D_CubismModelUserData* Create( const BYTE* buffer, size_t size ) ;				// CX^X̍쐬
	static void					Delete( D_CubismModelUserData* modelUserData ) ;			// CX^X̔j
	virtual ~D_CubismModelUserData() ;														// fXgN^
	const D_csmVector<const CubismModelUserDataNode*>& GetArtMeshUserDatas() const ;		// ArtMesh̃[Uf[^̃Xg̎擾

private:
	void ParseUserData( const BYTE* buffer, size_t size ) ;									// userdata3.jsoñp[X

	D_csmVector<const CubismModelUserDataNode*> _userDataNodes ;		// [Uf[^\̔z
	D_csmVector<const CubismModelUserDataNode*> _artMeshUserDataNodes ;	// {Xgێ
} ;

//  O錾
class D_CubismRenderer_DxLib ;
class D_CubismShader_DxLib ;
class D_CubismClippingContext ;

//  ItXN[`p\
class D_CubismOffscreenFrame_DxLib
{
public:
	D_CubismOffscreenFrame_DxLib() ;
	void						BeginDraw() ;												// w̕`^[QbgɌĕ`Jn
	void						EndDraw() ;													// `I
	void						Clear( float r, float g, float b, float a ) ;				// _O^[Qbg̃NA
	bool						CreateOffscreenFrame( DWORD displayBufferWidth, DWORD displayBufferHeight ) ;// CubismOffscreenFrame쐬
	void						DestroyOffscreenFrame() ;									// CubismOffscreenFrame̍폜
	void						SetClearColor( float r, float g, float b, float a ) ;		// NAJ[̏㏑
	int							GetTextureView() const ;									// eNX`r[ւ̃ANZbT
	DWORD						GetBufferWidth() const ;									// obt@擾
	DWORD						GetBufferHeight() const ;									// obt@擾
	bool						IsValid() const ;											// ݗLǂ

private:
	int							_GraphHandle ;				// eNX` 
	int							_BackupDrawScreen ;
	DWORD						_bufferWidth ;				// CreateɎw肳ꂽTCY 
	DWORD						_bufferHeight ;				// CreateɎw肳ꂽTCY 

} ;

// DirectX::XMMATRIXɕϊ
#ifndef DX_NON_NAMESPACE
DxLib::MATRIX D_ConvertToD3DX( D_CubismMatrix44& mtx ) ;
#else // DX_NON_NAMESPACE
MATRIX D_ConvertToD3DX( D_CubismMatrix44& mtx ) ;
#endif // DX_NON_NAMESPACE

//  NbsO}XN̏sNX
class D_CubismClippingManager_DxLib
{
	friend class D_CubismShader_DxLib ;
	friend class D_CubismRenderer_DxLib ;

private:
	D_CubismClippingManager_DxLib() ;														//  RXgN^
	virtual ~D_CubismClippingManager_DxLib() ;												//  fXgN^
	D_CubismRenderer::CubismTextureColor* GetChannelFlagAsColor( int channelNo ) ;			// J[`l(RGBA)̃tO擾
	void						CalcClippedDrawTotalBounds( D_CubismModel& model, D_CubismClippingContext* clippingContext ) ;// }XN`IuWFNgQŜ͂ދ`(fWn)vZ
	void						Initialize( D_CubismModel& model, int drawableCount, const int** drawableMasks, const int* drawableMaskCounts ) ;//  }l[W̏
	void						SetupClippingContext( D_CubismModel& model, D_CubismRenderer_DxLib* renderer, D_CubismOffscreenFrame_DxLib& useTarget ) ;// NbsOReLXg쐬Bf`掞ɎsB
	D_CubismClippingContext*	FindSameClip( const int* drawableMasks, int drawableMaskCounts ) const ;// Ƀ}XNĂ邩mFB
	void						SetupLayoutBounds( int usingClipCount ) const ;				// NbsOReLXgzu郌CAEgB
	D_CubismOffscreenFrame_DxLib* GetColorBuffer() const ;									// J[obt@̃AhX擾
	D_csmVector<D_CubismClippingContext*>* GetClippingContextListForDraw() ;				// ʕ`ɎgpNbsO}XÑXg擾
	void						SetClippingMaskBufferSize( int size ) ;						// NbsO}XNobt@̃TCYݒ肷
	int							GetClippingMaskBufferSize() const ;							// NbsO}XNobt@̃TCY擾

	D_CubismOffscreenFrame_DxLib*						_colorBuffer ;						// }XNpJ[obt@[̃AhX
	int													_currentFrameNo ;					// }XNeNX`ɗ^t[ԍ
	D_csmVector<D_CubismRenderer::CubismTextureColor*>	_channelColors ;
	D_csmVector<D_CubismClippingContext*>				_clippingContextListForMask ;		// }XNpNbsOReLXg̃Xg
	D_csmVector<D_CubismClippingContext*>				_clippingContextListForDraw ;		// `pNbsOReLXg̃Xg
	int													_clippingMaskBufferSize ;			// NbsO}XÑobt@TCYil:256j
	D_CubismMatrix44									_tmpMatrix ;						// }XNvZp̍s
	D_CubismMatrix44									_tmpMatrixForMask ;					// }XNvZp̍s
	D_CubismMatrix44									_tmpMatrixForDraw ;					// }XNvZp̍s
	D_csmRectF											_tmpBoundsOnModel ;					// }XNzuvZp̋`
} ;

// NbsO}XÑReLXg
class D_CubismClippingContext
{
	friend class D_CubismClippingManager_DxLib;
	friend class D_CubismShader_DxLib;
	friend class D_CubismRenderer_DxLib;

public:
	D_CubismClippingContext( D_CubismClippingManager_DxLib* manager, const int* clippingDrawableIndices, int clipCount ) ;// tRXgN^
	virtual ~D_CubismClippingContext() ;													// fXgN^
	void						AddClippedDrawable( int drawableIndex ) ;					// ̃}XNɃNbv`IuWFNgǉ
	D_CubismClippingManager_DxLib*	GetClippingManager() ;									// ̃}XNǗ}l[W̃CX^X擾B

	bool						_isUsing ;					// ݂̕`ԂŃ}XN̏KvȂtrue
	const int*					_clippingIdList ;			// NbsO}XNIDXg
	int							_clippingIdCount ;			// NbsO}XN̐
	int							_layoutChannelNo ;			// RGBẪ`lɂ̃Nbvzu邩(0:R , 1:G , 2:B , 3:A)
	D_csmRectF*					_layoutBounds ;				// }XNp`l̂ǂ̗̈Ƀ}XN邩(ViewW-1..1, UV0..1ɒ)
	D_csmRectF*					_allClippedDrawRect ;		// ̃NbsOŁANbsOSĂ̕`IuWFNg̈͂݋`iXVj
	D_CubismMatrix44			_matrixForMask ;			// }XN̈ʒuvZʂێs
	D_CubismMatrix44			_matrixForDraw ;			// `IuWFNg̈ʒuvZʂێs
	D_csmVector<int>*			_clippedDrawableIndexList ;	// ̃}XNɃNbv`IuWFNg̃Xg
	D_CubismClippingManager_DxLib* _owner;					// ̃}XNǗĂ}l[W̃CX^X
} ;

class D_CubismRenderer_DxLib ;

//  CubismDX11Őݒ肷Xe[ĝArŕύX\̂̂ǗBD_CubismRenderer_DxLibVOgƂĊǗB
class D_CubismRenderState_DxLib
{
	friend class D_CubismRenderer_DxLib;
public:
	enum
	{
		State_None								= 0,
		State_Blend								= 1,		// uh[h 
		State_Viewport							= 2,		// r[|[g 
		State_ZEnable							= 3,		// ZL 
		State_CullMode							= 4,		// JO[h 
		State_Sampler							= 5,		// eNX`tB^[ 
		State_Max								= 6,
	} ;
	// uhXe[g D3D11ł̓IuWFNgPʂł̊Ǘ 
	enum Blend
	{
		Blend_Origin							= 0,
		Blend_Zero								= 1,
		Blend_Normal							= 2,
		Blend_Add								= 3,
		Blend_Mult								= 4,
		Blend_Mask								= 5,
		Blend_Max								= 6,
	} ;
	// JO D3D11ł̓IuWFNgPʂł̊Ǘ 
	enum Cull
	{
		Cull_Origin								= 0,		// X̐ݒ 
		Cull_None								= 1,		// JO 
		Cull_Ccw								= 2,		// CCW\ 
		Cull_Max								= 3,
	} ;
	// Z D3D11ł̓IuWFNgPʂł̊Ǘ 
	enum Depth
	{
		Depth_Origin							= 0,		// X̐ݒ 
		Depth_Disable							= 1,		// Zoff 
		Depth_Enable							= 2,		// Zon 
		Depth_Max								= 3,
	} ;
	// Tv[Xe[g D3D11ł̓IuWFNgPʂł̊Ǘ 
	enum Sampler
	{
		Sampler_Origin							= 0,		// X̐ݒ 
		Sampler_Normal							= 1,		// gpXe[g 
		Sampler_Max								= 3,
	} ;

	// ftHg=ŃRs[܂
	struct Stored
	{
		Stored()
		{
			_blendState = Blend_Zero;
			_blendFactor_r = 0.0f;
			_blendFactor_g = 0.0f;
			_blendFactor_b = 0.0f;
			_blendFactor_a = 0.0f;
			_blendMask = 0xffffffff;
			_cullMode = Cull_None;
			_depthEnable = Depth_Disable;
			_depthRef = 0 ;
			_viewportX = 0 ;
			_viewportY = 0 ;
			_viewportWidth = 0 ;
			_viewportHeight = 0 ;
			_viewportMinZ = 0.0f;
			_viewportMaxZ = 0.0f;
			_sampler = Sampler_Normal;
		// DirectX::XMMATRIXɕϊ
		#ifndef DX_NON_NAMESPACE
			DxLib::_MEMSET( _valid, 0, sizeof( _valid ) ) ;
		#else // DX_NON_NAMESPACE
			_MEMSET( _valid, 0, sizeof( _valid ) ) ;
		#endif // DX_NON_NAMESPACE
		}
		// State_Blend 
		Blend					_blendState ;
		float					_blendFactor_r ;
		float					_blendFactor_g ;
		float					_blendFactor_b ;
		float					_blendFactor_a ;
		DWORD					_blendMask ;
		// State_CullMode 
		Cull					_cullMode ;
		// State_Viewport 
		float					_viewportX ;
		float					_viewportY ;
		float					_viewportWidth ;
		float					_viewportHeight ;
		float					_viewportMinZ ;
		float					_viewportMaxZ ;
		// State_ZEnable 
		Depth					_depthEnable ;
		DWORD					_depthRef ;
		// State_Sampler 
		Sampler					_sampler ;
		bool					_valid[ State_Max ] ;   // ݒ肵ǂB݂StartFrameňʂ͌Ăł 
	} ;

	void						StartFrame() ;												// t[擪ŌĂяo
	void						Save() ;													// Ǘ̃Xe[gPush
	void						Restore() ;													// PushXe[gPopASave̍ۂD_CubismRenderState_DxLibŐݒ肵ĂȂڂ͖߂ȂƂɒ
	void						SetBlend( Blend blendState, float blendFactor_r, float blendFactor_g, float blendFactor_b, float blendFactor_a, DWORD mask, bool force=false ) ;// uh[hZbg
	void						SetCullMode( Cull cullFace, bool force = false ) ;			// JO[hZbg
	void						SetViewport( float left, float top, float width, float height, float zMin, float zMax, bool force = false ) ;// r[|[gZbg
	void						SetZEnable( Depth enable, DWORD stelcilRef, bool force = false ) ;// ZLZbg
	void						SetSampler( Sampler sample, bool force = false ) ;			//  Tv[Xe[gZbg

private:
	D_CubismRenderState_DxLib() ;
	~D_CubismRenderState_DxLib() ;
	void						Create() ;													// eIuWFNg쐬
	void						SaveCurrentNativeState() ;									// D3DDeviceACubismɊ֌Wl擾D_CubismRenderState_DxLibɔfSaveĂяoA_pushed͔jACubismt[̍ŏAStartFraměŌĂł
	void						RestoreNativeState() ;										// ŏPushXe[g܂Ŗ߂

	Stored						_stored ;					// XgAꂽeݒ 
	D_csmVector<Stored>			_pushed ;
	int							backupBlendMode ;
	int							backupBlendParam ;
	int							backupCullMode ;
	int							backupUseZBuffer ;
	int							backupMaxAnisotropy ;
	int							backupDrawMode ;
	RECT						backupDrawArea ;
	int							backupDrawAlphaTestMode ;
	int							backupDrawAlphaTestParam ;
	int							backupDrawBright_r ;
	int							backupDrawBright_g ;
	int							backupDrawBright_b ;
} ;

enum D_ShaderNames
{
	// SetupMask
	D_ShaderNames_SetupMask									= 0,

	//Normal
	D_ShaderNames_Normal									= 1,
	D_ShaderNames_NormalMasked								= 2,
	D_ShaderNames_NormalMaskedInverted						= 3,
	D_ShaderNames_NormalPremultipliedAlpha					= 4,
	D_ShaderNames_NormalMaskedPremultipliedAlpha			= 5,
	D_ShaderNames_NormalMaskedInvertedPremultipliedAlpha	= 6,

	//Add
	D_ShaderNames_Add										= 7,
	D_ShaderNames_AddMasked									= 8,
	D_ShaderNames_AddMaskedInverted							= 9,
	D_ShaderNames_AddPremultipliedAlpha						= 10,
	D_ShaderNames_AddMaskedPremultipliedAlpha				= 11,
	D_ShaderNames_AddMaskedInvertedPremultipliedAlpha		= 12,

	//Mult
	D_ShaderNames_Mult										= 13,
	D_ShaderNames_MultMasked								= 14,
	D_ShaderNames_MultMaskedInverted						= 15,
	D_ShaderNames_MultPremultipliedAlpha					= 16,
	D_ShaderNames_MultMaskedPremultipliedAlpha				= 17,
	D_ShaderNames_MultMaskedInvertedPremultipliedAlpha		= 18,

	D_ShaderNames_Max										= 19,
} ;

//  O錾
class D_CubismRenderer_DxLib ;
class D_CubismClippingContext ;

// CubismŎgpVF[_ǗNXAD_CubismRenderer_DxLibstaticϐƂĈ̉
class D_CubismShader_DxLib
{
	friend class D_CubismRenderer_DxLib;

public:
	D_CubismShader_DxLib() ;																// privateȃRXgN^
	virtual ~D_CubismShader_DxLib() ;														// privateȃfXgN^
	void						ReleaseShaderProgram() ;									// VF[_vO
	int							GetVertexShader( DWORD assign ) ;							// _VF[_̎擾
	int							GetPixelShader( DWORD assign ) ;							// sNZVF[_̎擾
	void						SetupShader() ;												// _錾̃foCXւ̐ݒAVF[_܂ݒȂ烍[h

private:
	void						GenerateShaders() ;											// VF[_vO
	bool						LoadShaderProgram( bool isPs, int assign, const char* entryPoint ) ;// VF[_vO[h

	int							_shaderSetsVS[ D_ShaderNames_Max ] ;	// [hVF[_vOێϐ(VS) 
	int							_shaderSetsPS[ D_ShaderNames_Max ] ;	// [hVF[_vOێϐ(PS) 
} ;

// VF[_[RX^gobt@
struct D_CubismConstantBufferDxLib
{
#ifndef DX_NON_NAMESPACE
	DxLib::MATRIX				projectMatrix ;
	DxLib::MATRIX				clipMatrix ;
	DxLib::COLOR_F				baseColor ;
	DxLib::COLOR_F				multiplyColor ;
	DxLib::COLOR_F				screenColor ;
	DxLib::COLOR_F				channelFlag ;
#else // DX_NON_NAMESPACE
	MATRIX						projectMatrix ;
	MATRIX						clipMatrix ;
	COLOR_F						baseColor ;
	COLOR_F						multiplyColor ;
	COLOR_F						screenColor ;
	COLOR_F						channelFlag ;
#endif // DX_NON_NAMESPACE
} ;

// DirectX11p̕`施߂NX
class D_CubismRenderer_DxLib : public D_CubismRenderer
{
	friend class D_CubismRenderer;
	friend class D_CubismClippingManager_DxLib;
	friend class D_CubismShader_DxLib;

public:
	static void					InitializeConstantSettings( DWORD bufferSetNum ) ;			// _쐬邽߂̊eݒ
	static void					SetDefaultRenderState() ;									// CubismRenderStateɃftHg̐ݒZbg
	static void					StartFrame( DWORD viewportWidth, DWORD viewportHeight ) ;	// Cubism`֘A̐擪ōsBet[łCubismOɂĂł炤
	static void					EndFrame() ;												// Cubism`֘ȀIsBet[łCubismOɂĂł炤
	static D_CubismRenderState_DxLib* GetRenderStateManager() ;								// D_CubismRenderer_DxLibŎgp郌_[Xe[gǗ}l[W擾
	static void					DeleteRenderStateManager() ;								// _[Xe[gǗ}l[W폜
	static D_CubismShader_DxLib* GetShaderManager() ;										// VF[_Ǘ@\̎擾
	static void					DeleteShaderManager() ;										// VF[_Ǘ@\̍폜
	static void					OnDeviceLost() ;											// foCXXgEfoCXč쐬R[
	static void					GenerateShader() ;											// gpVF[_[쐬
	virtual void				Initialize( D_CubismModel* model, int ASyncThread ) ;		// _̏sAɓnf烌_̏ɕKvȏoƂł
	void						BindTexture( DWORD modelTextureAssign, int textureView ) ;	// OpenGLeNX`̃oChAD_CubismRendererɃeNX`ݒ肵AD_CubismRendererł̉摜QƂ邽߂Indexl߂lƂ
	const D_csmMap<int, int>&	GetBindedTextures() const ;									// OpenGLɃoChꂽeNX`̃Xg擾
	void						SetClippingMaskBufferSize( int size ) ;						//  NbsO}XNobt@̃TCYݒ肷A}XNpFrameBufferjEč쐬邽ߏRXg͍B
	int							GetClippingMaskBufferSize() const ;							//  NbsO}XNobt@̃TCY擾
	void						ExecuteDraw( int vertexBuffer, int indexBuffer, int constantBuffer, const int indexCount, const int textureNo, CubismTextureColor& modelColorRGBA, const CubismTextureColor& multiplyColor, const CubismTextureColor& screenColor, D_CubismBlendMode colorBlendMode, bool invertedMask ) ;	//  gpVF[_̐ݒERX^gobt@̐ݒȂǂsA`s

protected:
	D_CubismRenderer_DxLib() ;																// RXgN^
	virtual ~D_CubismRenderer_DxLib() ;														// fXgN^
	virtual void				DoDrawModel() ;												// f`悷ۂ̏
	void						DrawMesh( int textureNo, int indexCount, int vertexCount, WORD* indexArray, float* vertexArray, float* uvArray, float opacity, D_CubismBlendMode colorBlendMode, bool invertedMask ) ;
	void						DrawMeshDX11( int drawableIndex, int textureNo, int indexCount, int vertexCount, WORD* indexArray, float* vertexArray, float* uvArray, const CubismTextureColor& multiplyColor, const CubismTextureColor& screenColor, float opacity, D_CubismBlendMode colorBlendMode, bool invertedMask ) ;// `IuWFNgiA[gbVj`悷B|SbVƃeNX`ԍZbgœnB

private:
	static void					DoStaticRelease() ;											// _ێÓIȃ\[X
	static void					ReleaseShader() ;											// gpVF[_[ƒ_`̍폜
	D_CubismRenderer_DxLib( const D_CubismRenderer_DxLib& ) ;								// Prevention of copy Constructor
	D_CubismRenderer_DxLib&		operator=( const D_CubismRenderer_DxLib& ) ;
	void						PreDraw() ;													// `Jn̒ǉBf`悷OɃNbsO}XNɕKvȏĂB
	void						PostDraw() ;												// `抮̒ǉB
	virtual void				SaveProfile() ;												// f`撼ÕXe[gێ
	virtual void				RestoreProfile() ;											// f`撼ÕXe[gێ
	void						SetClippingContextBufferForMask( D_CubismClippingContext* clip ) ;// }XNeNX`ɕ`悷NbsOReLXgZbgB
	D_CubismClippingContext*	GetClippingContextBufferForMask() const ;					// }XNeNX`ɕ`悷NbsOReLXg擾B
	void						SetClippingContextBufferForDraw( D_CubismClippingContext* clip ) ;// ʏɕ`悷NbsOReLXgZbgB
	D_CubismClippingContext*	GetClippingContextBufferForDraw() const ;					// ʏɕ`悷NbsOReLXg擾B
	void						CopyToBuffer( int drawAssign, const int vcount, const float* varray, const float* uvarray ) ;// GetDrawableVertices,GetDrawableVertexUvs̓eobt@փRs[

	int**						_vertexBuffers ;			// _̃obt@ 
	int**						_indexBuffers ;				// CfbNX̃obt@ 
	int**						_constantBuffers ;			// 萔̃obt@
	DWORD						_drawableNum ;				// _vertexBuffers, _indexBuffers̊mې 
	int							_commandBufferNum ;
	int							_commandBufferCurrent ;
	D_csmVector<int>			_sortedDrawableIndexList ;	// `IuWFNg̃CfbNX`揇ɕׂXg
	D_csmMap<int, int>			_textures ;					// fQƂeNX`ƃ_ŃoChĂeNX`Ƃ̃}bv
	D_csmVector<D_CubismOffscreenFrame_DxLib>	_offscreenFrameBuffer ;			// }XN`p̃t[obt@ 
	D_CubismClippingManager_DxLib*				_clippingManager ;				// NbsO}XNǗIuWFNg
	D_CubismClippingContext*					_clippingContextBufferForMask ;	// }XNeNX`ɕ`悷邽߂̃NbsOReLXg
	D_CubismClippingContext*					_clippingContextBufferForDraw ;	// ʏ`悷邽߂̃NbsOReLXg
} ;

// [U[ۂɎgp郂f
class D_CubismUserModel
{
public:
	D_CubismUserModel() ;																	// RXgN^
	virtual ~D_CubismUserModel() ;															// fXgN^
	virtual bool				IsInitialized() ;											// Ԃ̎擾
	virtual void				IsInitialized( bool v ) ;									// Ԃ̐ݒ
	virtual bool				IsUpdating() ;												// XVԂ̎擾
	virtual void				IsUpdating( bool v ) ;										// XVԂ̐ݒ
	virtual void				SetDragging( float x, float y )	;							// }EXhbO̐ݒ
	virtual void				SetAcceleration( float x, float y, float z ) ;				// x̐ݒ
	D_CubismModelMatrix*		GetModelMatrix() const ;									// fs̎擾
	virtual void				SetOpacity( float a ) ;										// sx̐ݒ
	virtual float				GetOpacity() ;												// sx̎擾
	virtual void				LoadModel( const BYTE* buffer, size_t size ) ;				// ff[^̓ǂݍ
	virtual D_ACubismMotion*	LoadMotion( const BYTE* buffer, size_t size, const BYTE/*wchar_t*/ * name ) ;// [Vf[^̓ǂݍ
	virtual D_ACubismMotion*	LoadExpression( const BYTE* buffer, size_t size, const BYTE/*wchar_t*/ * name ) ;// \f[^̓ǂݍ
	virtual void				LoadPose( const BYTE* buffer, size_t size ) ;				// |[Yf[^̓ǂݍ
	virtual void				LoadPhysics( const BYTE* buffer, size_t size ) ;			// Zf[^̓ǂݍ
	virtual void				LoadUserData( const BYTE* buffer, size_t size ) ;			// fɕt郆[U[f[^ǂݍ
	virtual bool				IsHit( D_CubismIdHandle drawableId, float pointX, float pointY ) ;// 蔻̎擾
	D_CubismModel*				GetModel() const ;											// f̎擾
	D_CubismRenderer*			GetRenderer() { return _renderer ; }						// _̎擾
	void						CreateRenderer( int ASyncThread ) ;							// _̐
	void						DeleteRenderer() ;											// _̉
	virtual void				MotionEventFired( const D_csmString& eventValue ) ;			//  CxgΎ̕W
	static void					CubismDefaultMotionEventCallback( const D_CubismMotionQueueManager* caller, const D_csmString& eventValue, void* customData ) ;//  CxgpCallback

public:
	D_CubismMoc*				_moc ;						// Mocf[^
	D_CubismModel*				_model ;					// ModelCX^X
	D_CubismMotionManager*		_motionManager ;			// [VǗ
	D_CubismMotionManager*		_expressionManager ;		// \Ǘ
	D_CubismEyeBlink*			_eyeBlink ;					// ܂΂
	D_CubismBreath*				_breath ;					// ċz
	D_CubismModelMatrix*		_modelMatrix ;				// fs
	D_CubismPose*				_pose ;						// |[YǗ
	D_CubismTargetPoint*		_dragManager ;				// }EXhbO
	D_CubismPhysics*			_physics ;					// Z
	D_CubismModelUserData*		_modelUserData ;			// [Uf[^
	bool						_initialized ;				// ꂽǂ
	bool						_updating ;					// XVꂽǂ
	float						_opacity ;					// sx
	bool						_lipSync ;					// bvVN邩ǂ
	float						_lastLipSyncValue ;			// Ō̃bvVN̐l
	float						_dragX ;					// }EXhbOXʒu
	float						_dragY ;					// }EXhbOYʒu
	float						_accelerationX ;			// X̉x
	float						_accelerationY ;			// Ỷx
	float						_accelerationZ ;			// Z̉x
	bool						_debugMode ;				// fobO[hǂ

private:
	D_CubismRenderer*			_renderer ;      // _
} ;

class D_CubismString
{
public:
	static D_csmString			GetFormatedString( const char* format, ... ) ;						// Wo͂̏Kp擾B
	static bool					IsStartsWith( const char* text, const char* startWord ) ;			// textstartWordŎn܂Ă邩ǂԂ
	static float				StringToFloat( const char* string, int length, int position, int* outEndPos ) ;// positionʒu̕琔͂B

private:
	// RXgN^EfXgN^ĂяosȐÓINXɂ
	D_CubismString() ;
} ;

struct D_LAppModelParameter
{
	int							parameterIndex ;
	float						parameterValue ;
} ;

// [U[ۂɎgp郂f̎NXfAR|[lgAXVƃ_ǑĂяosB
class D_LAppModel : public D_CubismUserModel
{
public:
	D_LAppModel() ;																			// RXgN^
	virtual ~D_LAppModel() ;																// fXgN^
	bool						LoadAssets( const BYTE/*wchar_t*/ * dir, const BYTE/*wchar_t*/ * fileName, int ASyncThread ) ;	// model3.jsonuꂽfBNgƃt@CpX烂f𐶐
	void						ReloadRenderer( int ASyncThread ) ;							// _č\z
	void						Update( float deltaTimeSeconds ) ;							// f̍XVBf̃p[^`Ԃ肷B
	void						Draw( D_CubismMatrix44& matrix, bool isMultModelMatrix ) ;	// f`悷鏈Bf`悷ԂView-ProjectionsnB
	D_CubismMotionQueueEntryHandle StartMotion( const char* group, int no, int priority, float fadeInSeconds, float fadeOutSeconds, bool isLoopFadeIn = true ) ;	// Ŏw肵[V̍ĐJnB
	D_CubismMotionQueueEntryHandle StartRandomMotion( const char* group, int priority ) ;	// _ɑI΂ꂽ[V̍ĐJnB
	void						SetExpression( const BYTE/*wchar_t*/ * expressionID ) ;		// Ŏw肵\[VZbg
	void						SetRandomExpression() ;										// _ɑI΂ꂽ\[VZbg
	virtual void				MotionEventFired( const D_csmString& eventValue ) ;			// Cxg̔΂󂯎
	virtual bool				HitTest( const char* hitAreaName, float x, float y ) ;		//  蔻eXgB
	void						DeleteMark() { _deleteModel = true ; }						// fɍ폜}[Nt
	D_CubismOffscreenFrame_DxLib& GetRenderBuffer() ;										// ʃ^[Qbgɕ`悷ۂɎgpobt@̎擾
	void						SetUserParameter( int parameterIndex, float parameterValue ) ;	// [U[ݒ̃p[^ݒ肷

protected:
	void						DoDraw() ;													// f`悷鏈Bf`悷ԂView-ProjectionsnB

public:
	bool						SetupModel( D_ICubismModelSetting* setting ) ;				// model3.json烂f𐶐Bmodel3.json̋Lqɏ]ăfA[VAZȂǂ̃R|[lgsB
	void						SetupTextures( int ASyncThread ) ;							// eNX`[h
	void						PreloadMotionGroup( const char* group ) ;					// [Vf[^O[vꊇŃ[hB[Vf[^̖O͓ModelSetting擾B
	void						ReleaseMotionGroup( const char* group ) const ;				// [Vf[^O[vꊇŉB[Vf[^̖O͓ModelSetting擾B
	void						ReleaseMotions() ;											// ׂẴ[Vf[^̉
	void						ReleaseExpressions() ;										// ׂĂ̕\f[^̉

	D_ICubismModelSetting*		_modelSetting ;				// fZbeBO
	D_csmStringW				_modelHomeDir ;				// fZbeBOuꂽfBNg
	float						_userTimeSeconds ;			// f^Ԃ̐ώZl[b]
	D_csmVector<D_CubismIdHandle> _eyeBlinkIds ;			// fɐݒ肳ꂽ܂΂pp[^ID
	D_csmVector<D_CubismIdHandle> _lipSyncIds ;				// fɐݒ肳ꂽbvVNpp[^ID
	D_csmMap<D_csmStringW, D_ACubismMotion*> _motions ;		// ǂݍ܂Ă郂[ṼXg
	D_csmMap<D_csmStringW, D_ACubismMotion*> _expressions ;	// ǂݍ܂Ă\̃Xg
	D_csmVector<D_csmRectF>		_hitArea ;
	D_csmVector<D_csmRectF>		_userArea ;
	D_CubismId*					_idParamAngleX ;			// p[^ID: ParamAngleX
	D_CubismId*					_idParamAngleY ;			// p[^ID: ParamAngleX
	D_CubismId*					_idParamAngleZ ;			// p[^ID: ParamAngleX
	D_CubismId*					_idParamBodyAngleX ;		// p[^ID: ParamBodyAngleX
	D_CubismId*					_idParamEyeBallX ;			// p[^ID: ParamEyeBallX
	D_CubismId*					_idParamEyeBallY ;			// p[^ID: ParamEyeBallXY
	D_csmVector<int>			_bindTextureId ;			// eNX`ID 
	D_csmVector<D_LAppModelParameter>	_userParameters ;	// [U[ݒ̃p[^
	bool						_deleteModel ;				// ̏ŗ\tO DrawĂ΂Ȃ 
	D_CubismOffscreenFrame_DxLib _renderBuffer ;			// t[obt@ȊO̕` 
} ;

// e[u-----------------------------------------------------------------------

extern int Live2D_VertexShaderToDxLibShader_Table[ 7 ] ;
extern int Live2D_PixelShaderToDxLibShader_Table[ 7 ] ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern D_CubismIdManager *	new_D_CubismIdManager( void ) ;
extern void					delete_D_CubismIdManager( D_CubismIdManager *obj ) ;
extern D_LAppModel *		new_D_LAppModel( void ) ;
extern void					delete_D_LAppModel( D_LAppModel *obj ) ;
extern D_CubismMatrix44 *	new_D_CubismMatrix44( void ) ;
extern void					delete_D_CubismMatrix44( D_CubismMatrix44 *obj ) ;

#endif // DX_NON_LIVE2D_CUBISM4

#endif // DX_USECLIB_LIVE2DCUBISM4_H
